C     **************SUBROUTINES (BLOCK3)*******************************
C
      FUNCTION F3(F,TD,HLT,A)
      DIMENSION L(14),FI(14),A(24,26)
      DATA L/3*3,8*1,3*3/,FI/-90.,-80.,-70.,-60.,-40.,-30.,-10.,
     *10.,30.,40.,60.,70.,80.,90./
      I1=IFIX(HLT)+1
      I2=I1+1
      IF (I1.EQ.24) I2=1
      BT=HLT-IFIX(HLT)
      L2=1
      DO 1 I=2,14
      J=I-1
      L1=L2
      L2=L2+L(J)
      IF (F.LE.FI(I)) GO TO 2
    1 CONTINUE
    2 ALF=(F-FI(J))/(FI(J+1)-FI(J))
      IF ((L1.GT.9).AND.(L1.LT.18)) GO TO 3
      X1=XTD(TD,A(I1,L1),A(I1,L1+1),A(I1,L1+2))
      X2=XTD(TD,A(I2,L1),A(I2,L1+1),A(I2,L1+2))
      GO TO 4
    3 X1=A(I1,L1)
      X2=A(I2,L1)
    4 IF ((L2.GT.9).AND.(L2.LT.18)) GO TO 5
      X3=XTD(TD,A(I1,L2),A(I1,L2+1),A(I1,L2+2))
      X4=XTD(TD,A(I2,L2),A(I2,L2+1),A(I2,L2+2))
      GO TO 6
    5 X3=A(I1,L2)
      X4=A(I2,L2)
    6 F3=X1+ALF*(X3-X1)+BT*(X2-X1)+ALF*BT*(X4-X2-X3+X1)
      RETURN
      END
C
      SUBROUTINE TE250(FI,HOUR,TE)
      REAL TA1(4,12),TA2(28,12)
      COMMON /V2/TE2,TE3,TE4,VS35,VS,VSM,DT,DT25,T02,T03
     */V5/CF,C0,TI3 /D25/TA1,TA2
      IF(ABS(FI).LT.40.) GO TO 1
      TI3=XINT(TA1,FI,4,12)
      DT25=(TI3-C0)/2.
      GO TO 2
    1 DT25=(CF-C0)/2.
    2 T=HOUR-DT-DT25
      IF ((T.LT.0.).OR.(T.GE.24.)) T=ABS(ABS(T)-24.)
      TE0=XINT(TA2,T,28,12)
      TF0=T02+(T03-T02)*0.545
      TEF=TE2+(TE3-TE2)*0.545
      TE=(TE0-TF0)*VS+TEF
      IF (TE.LT.TEF) TE=TEF
      RETURN
      END
C
      SUBROUTINE TE350(FI,HOUR,TE)
      REAL TA1(17,12)
      COMMON /V1/CF1,C01,T4,TI4 /V2/TE2,TE3,TE4,VS,VS25,VSM,DT,DT250,
     *T02,T03/D35/ TA1 /V5/CF,C0,TI3
      IF(ABS(FI).LT.40.) GO TO 1
      DT35=(TI4-C01+TI3-C0)/2.
      GO TO 2
    1 DT35=(CF1-C01+CF-C0)/2.
    2 T=HOUR-DT-DT35
      IF ((T.GE.6.5).AND.(T.LE.21.)) GO TO 3
      IF (T.LT.6.5) T=6.5
      IF (T.GT.21.) T=21.
    3 TK=XINT(TA1,T,17,12)
      TF0=(T03+T4)/2.
      TEF=(TE3+TE4)/2.
      T035=T4*TK
      TE=(T035-TF0)*VS+TEF
      IF(TE.GT.TEF) TE=TEF
      RETURN
      END
C
      SUBROUTINE TE34(FI,TD,HOUR,TE3,TE4,CF03,CF04)
      COMMON /KOF/A,B1,C1,D1,B2,C2,D2,B3,C3,D3
      COMMON /KT/TT1,TT2
      AFI=ABS(FI)
      CALL COEF4(FI,TD,CF04)
      Z1=HOUR
      Z2=24-HOUR
      AT=Z1**3/(1+Z1**3)*Z2**3/(1+Z2**3)
      Z1=(FI+90)/3
      Z2=(-FI+90)/3
      A90=ZFUN(0.,1.,Z1)*ZFUN(0.,1.,Z2)
      DTE0=0.5*ZFUN(1.,-1.,(AFI-46.)/5.)+0.2*EFUN(AFI,58.,5.,2)
      DTE0=200.*(DTE0-0.5*EFUN(AFI,0.,12.,2))
      DA=DTE0*((1.-HOUR/5.6)*ZFUN(1.,-1.,(HOUR-4.)/0.2)*0.5+
     1         ZFUN(1.,1.,(HOUR-24.)/2.2))
      A=A+DA
      TE4=A+(B1*EFUN(HOUR,C1,D1,2)+B2*EFUN(HOUR,C2,D2,2)+B3*
     1  EFUN(HOUR,C3,D3,2))*AT*A90
      CALL COEF3(FI,TD,CF03)
      A=A+DA
      TE3=A+(B1*EFUN(HOUR,C1,D1,2)+B2*EFUN(HOUR,C2,D2,2)+B3*
     1     EFUN(HOUR,C3,D3,2))*AT*A90
      SFI=AFI-40.013
      SFI=SIGN(1.,SFI)
      V1=FI/25.473
      TT2=12.+4.5*COS(V1)*(1.-SFI)
      TT1=12.-2.75*ABS(COS(V1))**0.7*(1.-SFI)
      ALT=0.5*(ZFUN(1.,-1.,(HOUR-(TT1+0.5))/0.25)+
     1       ZFUN(1.,1.,(HOUR-(TT2-0.5))/0.25))
      IF(ALT.GT.1.) ALT=1.
      IF(TE4.GE.TE3) TEM=TE4
      IF(TE4.LT.TE3) TEM=TE3
      TE4=TEM*ALT+TE4*(1.-ALT)
      IF ((FI.EQ.0.).OR.(AFI.GE.40.)) GO TO 1
      CALL TCOR(FI,HOUR,TK3,TK4)
      TE3=TE3*TK3
      TE4=TE4*TK4
      TEM=TE4
      IF(TE4.LT.TE3) TEM=TE3
      TE4=TEM*ALT+TE4*(1.-ALT)
    1 RETURN
      END
C
      SUBROUTINE TE600(FI,TD,HOUR,TE)
      REAL TA1(24,26),TA3(3,13),TA2(12,12),K
      COMMON /V1/C1,C04,T4,TI4 /V2/TE2,TE3,TE4,VS,VS25,VSM,DT,DT250,
     *T02,T03/D6/TA1,TA2,TA3
      IF(ABS(FI).LT.40.) GO TO 1
      TI4=XINT(TA2,FI,12,12)
      TI46=TI4
      GO TO 2
    1 TI46=C1
    2 DT1=TI46-TM(FI,TD,TA3)
      T=HOUR-DT1
      IF ((T.LT.0.).OR.(T.GE.24.)) T=ABS(ABS(T)-24.)
      K=F3(FI,TD,T,TA1)
      TE=TE4*K
      RETURN
      END
C
      SUBROUTINE TEMAX(FI,HOUR,H,TE)
      REAL TA1(17,12),TA2(17,12)
      COMMON /DMAX/TA1,TA2 /V2/ TE2,TE3,TE4,VS35,VS25,VS,DT,DT25,T02,T03
      T=HOUR-DT-DT25
      IF ((T.GE.6.5).AND.(T.LE.21.)) GO TO 1
      IF (T.LT.6.5) T=6.5
      IF (T.GT.21.) T=21.
    1 H0=XINT(TA1,T,17,12)
      H=(H0-200.)*EXP(-1.266E-03*FI*FI)+200.
      T0=XINT(TA2,T,17,12)
      TF0=T02+(T03-T02)/110.*(H0-190.)
      TF=TE2+(TE3-TE2)/110.*(H-190.)
      TE=(T0-TF0)*VS+TF
      IF (TE.LT.TF) TE=TF
      RETURN
      END
C
      SUBROUTINE T1400(FI,HOUR,TE)
      DIMENSION XX(24,5),YI1(7,5),YI2(7,5),VI1(19,5),VI2(19,5),
     *X(5),Y(5,2),V(5,2),SDAY(12)
      COMMON /BLOCD/MONTH,NDATE
      DATA SDAY /0.,31.,59.,90.,120.,151.,181.,212.,243.,273.,304.,334./
      DATA XX/0.1332,0.1307,0.1313,0.1351,0.1472,0.1733,0.2156,0.2437,
     10.2452,0.2430,0.2410,0.2395,0.2367,0.2333,0.2373,0.2461,0.2513,
     20.2462,0.2233,0.1964,0.1775,0.1625,0.1457,0.1374,0.2791,0.2923,
     30.3143,0.3355,0.3401,0.2369,-0.0174,-0.1996,-0.1762,-0.1490,
     4-0.1413,-0.1349,-0.1070,-0.0653,-0.0783,-0.1375,-0.1825,-0.1837,
     5-0.0821,0.0682,0.1517,0.1983,0.2536,0.2760,-0.1620,-0.2638,-0.3417
     6,-0.3228,-0.0021,0.3265,0.1398,-0.3698,-0.0356,0.0701,-0.0817,
     7-0.0615,0.0598,0.0792,0.0179,-0.0288,0.0392,-0.0611,-0.1618,0.2161
     8,0.4491,0.3247,0.0852,-0.0104,-0.0112,-0.0094,0.0015,0.0203,0.0270
     9,-0.2196,-0.4799,-0.3132,-0.2200,-0.2086,-0.1311,-0.1851,-0.1458,
     A0.1445,0.2924,0.2633,0.2876,0.3016,0.2759,0.1636,0.0332,0.0220,
     B0.0552,0.0222,-0.0952,-0.0872,-0.0374,0.0935,0.3447,0.4599,0.1622,
     C0.0941,0.1310,-0.0877,-0.1892,-0.2194,-0.3044,-0.0835,0.1148,
     D0.1168,0.3076,0.2636,-0.2092,-0.2924,-0.1257,-0.1518,-0.1483,
     E-0.1352/
      DATA YI1/0.3653,0.3693,0.3756,0.3825,0.3837,0.3852,0.3836,
     10.3034,0.3271,0.3638,0.3895,0.4043,0.4175,0.4233,
     20.6041,0.3397,-0.2440,-0.4913,-0.3139,0.1019,0.3313,
     30.2066,0.3105,0.5551,0.6133,0.4068,0.0642,-0.0834,
     40.6200,0.5244,0.2566,0.0820,-0.0810,-0.2907,-0.4207/
      DATA YI2/-0.6180,-0.4458,-0.1385,0.0919,0.2565,0.3626,0.4409,
     20.6791,0.5146,0.1063,-0.1644,-0.2682,-0.2897,-0.2829,
     30.1610,0.1748,0.2960,0.3647,0.4278,0.5014,0.5372,
     40.1845,0.1086,-0.0929,-0.0899,0.1590,0.5502,0.7807,
     50.1399,0.2147,0.3623,0.4536,0.5062,0.4453,0.3780/
      DATA VI1/31523.,33639.,37140.,39736.,39258.,36750.,34037.,32385.,
     131479.,31401.,31974.,33195.,34888.,37029.,39214.,39594.,37582.,
     234522.,32927.,7080.,5615.,4321.,2538.,-149.,-3029.,-4936.,-5887.,
     3-5972.,-5893.,-6087.,-6196.,-5344.,-2931.,494.,3412.,4815.,5980.,
     47642.,-109.,-138.,-192.,145.,803.,1502.,1619.,1387.,1253.,
     51196.,1270.,1325.,1186.,1050.,856.,431.,-43.,-123.,-20.,
     6-73.,-340.,-258.,-50.,511.,882.,1052.,434.,-398.,-777.,
     7-366.,596.,1045.,1288.,1395.,1246.,498.,-32.,-69.,
     8-198.,-96.,228.,295.,-13.,152.,923.,1535.,1695.,1618.,
     91381.,1127.,699.,10.,-397.,79.,356.,189.,-25./
      DATA VI2/-4539.,-3459.,-1841.,-757.,-713.,-1031.,-252.,267.,
     1389.,-8.,-918.,-1458.,-1098.,-786.,-283.,720.,3148.,5744.,
     26769.,1675.,2177.,1701.,656.,296.,695.,893.,749.,557.,303.,
     3245.,155.,346.,1037.,1498.,874.,-287.,-977.,-808.,
     4-561.,-820.,-930.,-388.,579.,714.,109.,-823.,-1395.,-1162.,
     5-551.,-4.,463.,918.,1209.,820.,68.,-490.,-666.,
     6-49.,-879.,-1273.,-381.,584.,528.,-126.,-659.,-948.,
     7-942.,-1173.,-1154.,-762.,-210.,71.,-409.,-780.,-503.,
     8-66.,-473.,146.,958.,964.,73.,-520.,-220.,221.,437.,
     9-183.,-359.,-391.,-490.,-601.,-600.,-126.,32.,-285.,-544./
      K=IFIX(FI/10.)
      IF((FI.GT.-90.).AND.(FI.LT.0.)) K=K-1
      IF(FI.GE.80.) K=8
      KF=K+10
      FPR=(FI-10.*K)*0.1
      IF(MONTH.LT.7) GO TO 1
      KM1=14-MONTH
      KM2=KM1-1
      GO TO 2
   1  KM1=MONTH
      KM2=MONTH+1
   2  PRM=(NDATE-1)/31.
      IF(MONTH.LT.12) PRM=(NDATE-1)/(SDAY(MONTH+1)-SDAY(MONTH))
      IF(HOUR.LT.23.) GO TO 3
      IX1=24
      IX2=1
      GO TO 4
   3  IX1=IFIX(HOUR)+1
      IX2=IX1+1
   4  HPR=HOUR-IFIX(HOUR)
      DO 5 I=1,5
      Y(I,1)=YI1(KM1,I)+PRM*(YI1(KM2,I)-YI1(KM1,I))
      Y(I,2)=YI2(KM1,I)+PRM*(YI2(KM2,I)-YI2(KM1,I))
      V(I,1)=VI1(KF,I)+FPR*(VI1(KF+1,I)-VI1(KF,I))
      V(I,2)=VI2(KF,I)+FPR*(VI2(KF+1,I)-VI2(KF,I))
      X(I)=XX(IX1,I)+HPR*(XX(IX2,I)-XX(IX1,I))
    5 CONTINUE
      SUM=0
      DO 6 I=1,5
      DO 6 J=1,2
      SUM=SUM+X(I)*Y(I,J)*V(I,J)
    6 CONTINUE
      TE=SUM
      RETURN
      END
C
      REAL FUNCTION TERO(DLTR,TE,H,RD1,RD2,RT1,RT2)
      COMMON /BLO11/XHI
      TEN=XXE(H)
      IF (XHI.LE.80.0) GO TO 1
      TERO=TE+DLTR*RT1
      IF (TEN.GT.5.0E+11) TERO=TE+DLTR*RT2
      GO TO 2
    1 TERO=TE+DLTR*RD1
      IF (TEN.GT.5.0E+11) TERO=TE+DLTR*RD2
    2 RETURN
      END
C
      SUBROUTINE TCOR(FMAGB,HOUR,TK3,TK4)
      DIMENSION TMK31(7,24),TMK32(7,24),TMK41(7,24),TMK42(7,24),
     *XX3(2),XX4(2),SDAY(12)
      COMMON /BLOCD/MONTH,NDATE
      DATA SDAY /0.,31.,59.,90.,120.,151.,181.,212.,243.,273.,304.,334./
      DATA PI /3.1415927/
      DATA TMK31/1.01,0.99,1.01,1.03,1.06,1.07,1.08,1.02,1.,1.02,1.04,
     11.06,1.08,1.07,1.,0.98,0.98,1.05,1.07,1.01,1.,0.98,0.95,0.97,1.05,
     21.04,0.96,0.92,0.90,0.87,0.89,0.97,1.01,0.91,0.90,0.85,0.81,0.79,
     30.86,0.85,0.87,0.92,0.99,0.95,0.84,0.86,0.89,0.99,1.06,0.95,0.90,
     40.94,1.01,1.05,1.13,1.11,0.99,0.95,0.97,0.95,1.01,1.04,1.06,1.02,
     50.97,0.92,0.85,0.99,1.12,1.12,1.,0.96,0.88,0.79,0.90,1.15,1.13,
     60.94,0.91,0.83,0.85,1.01,1.10,1.10,0.88,0.87,0.87,0.99,1.08,1.06,
     71.07,0.85,0.85,0.88,1.,1.09,1.04,1.04,0.76,0.74,0.84,0.94,1.08,
     81.01,1.02,0.76,0.76,0.81,0.89,1.07,1.,1.01,0.80,0.82,0.85,0.90,
     91.08,1.,1.02,0.89,0.91,0.94,0.97,1.10,1.03,1.11,1.02,1.04,1.07,
     A1.03,1.10,1.11,1.15,1.13,1.13,1.16,1.08,1.06,1.04,1.07,1.09,1.07,
     B1.06,1.08,1.11,1.1,1.17,1.05,1.03,1.01,1.05,1.1,1.13,1.18,1.06,
     C1.04,1.02,1.03,1.09,1.11,1.16,1.05,1.03,1.02,1.02,1.07,1.10,1.12/
      DATA TMK32/1.10,1.09,1.05,1.02,1.02,0.95,0.96,1.09,1.10,1.05,
     11.03,1.03,0.94,0.95,1.,1.02,1.04,1.03,1.01,0.90,0.91,0.91,0.94,
     21.01,1.01,0.96,0.88,0.90,0.87,0.92,0.97,0.97,0.90,0.87,0.86,0.88,
     30.96,0.84,0.81,0.79,0.82,0.85,0.87,0.91,0.90,0.88,0.94,0.95,0.98,
     40.97,1.01,1.06,1.05,0.96,0.92,0.95,0.92,0.98,0.96,1.09,0.99,0.94,
     50.98,0.87,0.89,0.90,0.94,0.95,0.95,0.98,0.91,0.91,0.93,0.98,0.94,
     60.95,1.,0.92,0.92,0.96,0.98,0.9,0.9,0.95,0.9,0.91,1.,0.96,0.87,
     70.86,0.9,0.88,0.89,0.97,0.94,0.85,0.8,0.86,0.84,0.85,0.93,0.94,
     80.85,0.76,0.81,0.84,0.84,0.93,0.94,0.87,0.77,0.78,0.91,0.89,0.97,
     90.99,0.92,0.81,0.83,1.04,1.02,1.03,1.05,0.98,0.9,0.92,1.08,1.07,
     A1.11,1.14,1.07,1.04,1.06,1.10,1.11,1.14,1.12,1.15,1.14,1.16,1.15,
     B1.16,1.09,1.08,1.05,1.08,1.10,1.19,1.11,1.07,1.06,1.02,1.03,1.,
     C1.16,1.1,1.04,1.05,1.02,1.03,1.01,1.12,1.10,1.05,1.03,1.02,1.01,
     D0.99/
      DATA TMK41/1.,1.,1.05,1.11,1.09,1.08,1.09,0.98,1.,1.05,1.14,1.09,
     11.08,1.1,0.95,0.96,1.,1.11,1.05,1.04,1.07,0.93,0.93,0.97,1.05,1.03
     2,1.,1.02,0.85,0.87,0.91,0.96,1.01,1.,1.03,0.72,0.76,0.80,0.83,
     30.94,1.,1.,0.90,0.87,0.85,0.74,0.91,0.88,0.89,0.93,0.89,0.89,0.96,
     40.96,0.89,0.81,0.91,0.87,0.85,0.93,0.95,0.97,0.92,0.94,0.92,0.86,
     50.84,0.93,0.95,0.98,0.94,0.94,0.93,0.90,0.99,1.,1.,0.89,0.89,0.95,
     60.92,0.97,1.01,1.02,0.76,0.82,0.94,0.92,0.96,0.97,0.98,0.68,0.79,
     70.92,0.91,0.94,0.93,0.92,0.67,0.76,0.91,0.95,0.97,0.93,0.96,0.67,
     80.74,0.91,0.98,1.,0.97,0.98,0.72,0.78,0.95,0.98,1.01,1.,1.02,0.72,
     80.82,0.98,0.98,1.,0.99,1.,0.84,0.76,0.95,0.96,1.,1.,1.07,0.79,
     A0.79,0.85,0.90,1.05,1.08,1.18,0.85,0.86,0.89,0.94,1.13,1.18,1.31,
     B0.92,0.92,0.94,1.04,1.1,1.23,1.32,0.97,0.99,1.03,1.1,1.1,1.19,1.24
     C,1.,1.,1.07,1.12,1.10,1.15,1.18/
      DATA TMK42/1.13,1.10,1.13,1.12,1.12,1.01,1.01,1.12,1.10,1.13,1.12,
     11.12,1.02,0.98,1.03,1.06,1.08,1.06,1.08,0.97,0.92,0.94,1.02,1.03,
     21.04,1.02,0.93,0.87,1.01,1.10,0.96,0.89,0.94,0.87,0.83,1.05,1.07,
     30.91,0.73,0.82,0.82,0.77,0.98,0.93,0.93,0.77,0.85,0.90,0.89,1.01,
     41.03,1.02,0.94,0.91,0.91,0.95,1.09,1.03,0.97,0.96,0.87,0.91,
     50.99,1.,0.95,0.99,1.,0.92,0.97,1.,1.01,1.02,1.,0.99,0.95,0.97,
     61.06,1.12,1.12,1.02,0.99,0.96,0.93,1.05,1.15,1.14,1.03,0.99,0.95,
     70.87,0.99,1.11,1.09,1.01,0.99,0.95,0.83,0.91,1.01,0.98,0.96,1.01,
     80.97,0.84,0.84,0.93,0.89,0.88,1.,0.96,0.79,0.78,1.,0.94,0.91,0.99,
     90.97,0.89,0.85,1.12,1.08,1.02,1.01,0.99,0.89,0.84,1.24,1.22,1.21,
     A1.11,1.02,0.90,0.85,1.42,1.39,1.33,1.21,1.09,0.94,0.86,1.51,1.42,
     B1.33,1.28,1.17,0.98,0.87,1.46,1.36,1.30,1.24,1.17,0.99,0.92,1.37,
     C1.32,1.26,1.22,1.19,1.03,0.97,1.20,1.20,1.15,1.16,1.17,1.04,1.02/
      IF(MONTH.LT.7) GO TO 1
      M1=14-MONTH
      M2=M1-1
      GO TO 2
   1  M1=MONTH
      M2=MONTH+1
   2  DPR=(NDATE-1)/31.
      IF(MONTH.LT.12) DPR=(NDATE-1)/(SDAY(MONTH+1)-SDAY(MONTH))
      IF(HOUR.LT.23.) GO TO 3
      I1=24
      I2=1
      GO TO 4
   3  I1=IFIX(HOUR)+1
      I2=I1+1
   4  HPR=HOUR-IFIX(HOUR)
      IF (FMAGB.GT.0.) GO TO 5
      XX3(1)=TMK31(M1,I1)+HPR*(TMK31(M1,I2)-TMK31(M1,I1))
      XX3(2)=TMK31(M2,I1)+HPR*(TMK31(M2,I2)-TMK31(M2,I1))
      XX4(1)=TMK41(M1,I1)+HPR*(TMK41(M1,I2)-TMK41(M1,I1))
      XX4(2)=TMK41(M2,I1)+HPR*(TMK41(M2,I2)-TMK41(M2,I1))
      GO TO 6
   5  XX3(1)=TMK32(M1,I1)+HPR*(TMK32(M1,I2)-TMK32(M1,I1))
      XX3(2)=TMK32(M2,I1)+HPR*(TMK32(M2,I2)-TMK32(M2,I1))
      XX4(1)=TMK42(M1,I1)+HPR*(TMK42(M1,I2)-TMK42(M1,I1))
      XX4(2)=TMK42(M2,I1)+HPR*(TMK42(M2,I2)-TMK42(M2,I1))
   6  X3=XX3(1)+DPR*(XX3(2)-XX3(1))
      X4=XX4(1)+DPR*(XX4(2)-XX4(1))
      AMAGB=ABS(FMAGB)
      YARG=1.-AMAGB/60.0+AMAGB*AMAGB/600.0
      YAR=YARG*(AMAGB-20.0)*PI/40.0
      Y=0.5*(1.+SIN(YAR))
      TK3=1.+(X3-1.)*Y
      TK4=1.+(X4-1.)*Y
      RETURN
      END
C
      SUBROUTINE ORDER(H1,TE,H)
      REAL H(9),TE(9),H1(9)
      COMMON /DM/NI
      DO 3 I=1,NI
    3 H(I)=H1(I)
      N1=NI-1
      DO 1 I=1,N1
      I1=I+1
      DO 1 J=I1,NI
      IF(H(I)-H(J)) 1,1,2
    2 XP=H(I)
      TP=TE(I)
      H(I)=H(J)
      TE(I)=TE(J)
      H(J)=XP
      TE(J)=TP
    1 CONTINUE
      RETURN
      END
C
      SUBROUTINE RTE(BM,HI)
C  SELECTION AND INTERPOLATION WITH LATITUDE AND ZENITH ANGLE
C  OF COEFFICIENTS TE1, TE2
      DIMENSION SHN(6),SHIN(6)
      REAL*8 T1(6),T2(6),A11,A21,INTP,ATE1(6,6,6),ATE2(6,6,6)
      COMMON/B3/ATE1,ATE2/B4/T1,T2
      DATA SHN/5.,15.,25.,35.,45.,54./,SHIN/40.,50.,70.,90.,110.,120./
      IF ((BM.GT.SHN(1)).AND.(BM.LT.SHN(6))) GO TO 1
      IF (BM.LE.SHN(1)) NFI1=1
      IF (BM.GE.SHN(6))NFI1=6
      NFI2=NFI1
      DFI=1.0
      GO TO 4
    1 DO 2 I=2,6
      NFI2=I
      IF ((BM.GT.SHN(I-1)).AND.(BM.LE.SHN(I))) GO TO 3
    2 CONTINUE
    3 NFI1=NFI2-1
      DFI=(BM-SHN(NFI1))/(SHN(NFI2)-SHN(NFI1))
    4 IF ((HI.GT.SHIN(1)).AND.(HI.LT.SHIN(6))) GO TO 5
      IF (HI.LE.SHIN(1)) NHI1=1
      IF (HI.GE.SHIN(6)) NHI1=6
      NHI2=NHI1
      DHI=1.
      GO TO 10
    5 DO 6 I=2,6
      NHI2=I
      IF ((HI.GT.SHIN(I-1)).AND.(HI.LE.SHIN(I))) GO TO 7
    6 CONTINUE
    7 NHI1=NHI2-1
      DHI=(HI-SHIN(NHI1))/(SHIN(NHI2)-SHIN(NHI1))
C INTERPOLATION WITH ZENITH ANDLE FOR  T1
   10 DO 8 I=1,6
      A11=INTP(ATE1(NFI1,NHI1,I),ATE1(NFI1,NHI2,I),DHI)
      A21=INTP(ATE1(NFI2,NHI1,I),ATE1(NFI2,NHI2,I),DHI)
C INTERPOLATION WITH LATITUDE FOR T1
      T1(I)=INTP(A11,A21,DFI)
C INTERPOLATION WITH ZENITH ANDLE FOR  T2
      A11=INTP(ATE2(NFI1,NHI1,I),ATE2(NFI1,NHI2,I),DHI)
      A21=INTP(ATE2(NFI2,NHI1,I),ATE2(NFI2,NHI2,I),DHI)
C INTERPOLATION WITH LATITUDE FOR T2
    8 T2(I)=INTP(A11,A21,DFI)
    9 RETURN
      END
C
      SUBROUTINE OPFUN(XFI,HOUR,DAY,F9,VS25,VSM)
      FI=ABS(XFI)
      AEX=(-FI*FI)/225.
      A=1-EXP(AEX)
      F4=(FI/23.1)**3.5
      F4=1/(1+F4)
      X=(FI-27.)/7.
      X=ABS(X)
      F7=0.5*A/(1+X**3)+F4
      IF((DAY.LE.32.).OR.(DAY.GE.335.)) GO TO 1
      X=(FI-36.)/(16.5-0.07*FI-1.2E-03*FI*FI)
      X=ABS(X)
      X14=2.55*A/(1+X**3)
      F3=F4+X14/8.
      IF(HOUR.LE.16.) GO TO 12
      F2=X14/3.3+F4
      X=(FI-30.)/(12.2-0.15*FI)
      X=ABS(X)
      F6=F4+0.9*A/(1+X**3)
  12  IF((DAY.LT.105.).OR.(DAY.GT.196.)) GO TO 2
      IF(HOUR.GE.8.) GO TO 3
      VS25=F9+((F3-F9)*(HOUR-6.5)/1.5)
      VSM=F9+((F7-F9)*(HOUR-6.5)/1.5)
      GO TO 8
  3   VS25=F3
      VSM=F7
      IF(HOUR.GT.16) GO TO 4
      GO TO 8
  4   F1=F4+X14
      X=(FI-30.)/(11.6-0.15*FI)
      X=ABS(X)
      F5=F4+1.6*A/(1.+X**3)
      IF((DAY.GE.135.).AND.(DAY.LE.166.)) GO TO 5
      IF(DAY.GT.166.) GO TO 6
      F1=F2+(F1-F2)*(DAY-105.)/30.
      F5=F6+(F5-F6)*(DAY-105.)/30.
      GO TO 5
   6  F1=F1+(F2-F1)*(DAY-166.)/30.
      F5=F5+(F6-F5)*(DAY-166.)/30.
   5  IF(HOUR.GT.18.) GO TO 7
      VS25=F3+(F1-F3)*(HOUR-16.)/2.
      VSM=F7+(F5-F7)*(HOUR-16.)/2.
      GO TO 8
   7  VS25=F1+(F9-F1)*(HOUR-18.)/3.
      VSM=F5+(F9-F5)*(HOUR-18.)/3.
      GO TO 8
   2  IF(HOUR.GE.18.) GO TO 9
      IF (DAY.LT.105.) FX1=F4+(F3-F4)*(DAY-32.)/73.
      IF (DAY.LT.105.) FM1=F4+(F7-F4)*(DAY-32.)/73.
      IF (DAY.GT.196.) FX1=F3+(F4-F3)*(DAY-196.)/139.
      IF (DAY.GT.196.) FM1=F7+(F4-F7)*(DAY-196.)/139.
      IF(HOUR.GE.8.) GO TO 10
      VS25=F9+(FX1-F9)*(HOUR-6.5)/1.5
      VSM=F9+(FM1-F9)*(HOUR-6.5)/1.5
      GO TO 8
  10  IF (HOUR.GT.16.) GO TO 9
      VS25=FX1
      IF (HOUR.LT.14.) VSM=FM1+(F7-FM1)*(HOUR-8.)/6.
      IF ((HOUR.GE.14.).AND.(HOUR.LE.16.)) VSM=FM1
      GO TO 8
    9 IF (DAY.LT.105.) FX2=F4+(F2-F4)*(DAY-32.)/73.
      IF (DAY.LT.105.) FM2=F4+(F6-F4)*(DAY-32.)/73.
      IF (DAY.GT.196.) FX2=F2+(F4-F2)*(DAY-196.)/139.
      IF (DAY.GT.196.) FM2=F6+(F4-F6)*(DAY-196.)/139.
      IF(HOUR.GT.18.) GO TO 11
      VS25=FX1+(FX2-FX1)*(HOUR-16.)/2.
      VSM=F7+(FM2-F7)*(HOUR-16.)/2.
      GO TO 8
  11  VS25=FX2+(F9-FX2)*(HOUR-18.)/3.
      VSM=FM2+(F9-FM2)*(HOUR-18.)/3.
      GO TO 8
  1   VS25=F4
      IF(HOUR.LT.8.) VS25=F9+(F4-F9)*(HOUR-6.5)/1.5
      IF(HOUR.GT.18.) VS25=F4+(F9-F4)*(HOUR-18.)/3.
      VSM=F7
      IF((HOUR.LE.8.).OR.(HOUR.GE.18.)) VSM=VS25
      IF((HOUR.GT.8.).AND.(HOUR.LT.14.)) VSM=F4+(F7-F4)*(HOUR-8.)/6.
      IF((HOUR.GT.16.).AND.(HOUR.LT.18.)) VSM=F7+(F4-F7)*(HOUR-16.)/2.
    8 RETURN
      END
C
C     11. SUBROUTINES FOR DATA PREPARATION FOR CALCULATION
C            PROFILE OF ELECTRON COLLISION FREQUENCY.
C
      SUBROUTINE FKNUH(ABSLAT)
      DIMENSION APR1(100),APR2(100),APR(200)
      COMMON /BLKK1/ APR,LP,DELFI
      DATA APR1/4.45941,-7.05114,-2.54189,-3.45324,4.00912,-15.4102,
     1-6.68853,-5.58309,2.67133,0.570360,0.917253,-2.81163,-52.996,
     297.8097,-49.2446,168.638,-6.6728,18.4534,-13.162,-2.38122,
     3106.581,-116.502,1803.87,-3764.92,2035.45,4.45405,-7.11869,
     4-2.14934,-3.92853,4.15437,0.112452,-8.35238,18.2903,-36.9423,
     520.4473,0.801969,-4.83393,-31.0139,57.2433,-28.5429,137.851,
     6151.517,441.625,-1036.05,561.831,107.232,199.11,-791.039,
     7933.554,-386.117,4.43965,-7.2255,-1.52145,-4.83665,4.54956,
     80.939394,-7.29064,5.31695,-15.875,10.6421,0.179138,-8.10184,
     910.2735,-17.8783,9.13397,165.498,66.012,332.084,-626.569,
     A324.311,114.173,233.015,-1141.98,1540.87,-674.922,4.41,-7.29496,
     B-1.35148,-5.19971,4.76026,1.48957,1.44602,-44.7335,51.604,
     C-16.4203,-0.0194907,-1.96746,-15.6486,16.7554,-6.17123,188.257,
     D-492.017,3568.8,-7450.29,4111.85,145.889,194.77,-1116.84,
     E1427.03,-565.865/
      DATA APR2/4.38936,-7.30042,-1.48869,-5.24751,4.88531,2.24913,
     1-1.60097,-33.4223,46.3152,-20.209,0.012833,-1.32161,-22.8992,
     226.4477,-10.3176,178.921,39.7102,66.8389,-1383.94,1082.68,
     3189.762,-49.7066,33.512,-587.264,511.167,4.37309,-7.361,
     40.804124,-6.83583,5.83149,2.68054,-0.395164,-37.3868,50.9101,
     5-22.0531,0.44032,-0.0512723,-26.2865,23.0248,-4.97322,174.132,
     6-27.021,613.919,-2416.66,1676.31,203.756,-13.5697,43.1208,
     7-929.093,818.756,4.34071,-7.36324,-0.0492524,-8.52384,6.78731,
     82.86251,1.25366,-41.0417,49.8547,-18.961,0.987967,-2.20783,
     9-19.8081,19.7244,-5.65387,178.785,-218.213,2038.46,-5028.08,
     A3073.95,187.679,147.302,-631.593,247.64,170.046,4.29795,-7.26884,
     B-0.213551,-8.67317,6.97062,3.0085,-1.05869,-20.2952,5.43144,
     C6.90637,1.16152,-1.73517,-16.6756,12.4922,-1.80866,185.431,
     D-331.039,3071.14,-7391.21,4552.63,175.845,29.4573,-7.6277,
     E-571.439,497.893/
      DO 10 I=1,100
      APR(I)=APR1(I)
 10   APR(100+I)=APR2(I)
      LP=INT(ABSLAT/10.+1.)
      IF(LP.LT.8)GO TO 20
      LP=8
      DELFI=0
      RETURN
 20   DELFI=ABSLAT/10.-LP+1.
      RETURN
      END
C
C       12. SUBROUTINES FOR CALCULATIONS OF PARAMETERS OF ATMOSPHERE
C                     WITH MODEL JACCIA-77
C
C        SUBROUTINE J77 AND ALL FOLLOWING AFTER IT SUBROUTINES PRESENT
C     FINAL PROGRAM OF MODEL JACCIA-77 WHICH IS REGISTERED IN THE
C     INFORMATION FOUNDATION OFAP OF METEOROLOGICAL SERVICE OF USSR
C     (IO639), AND WAS USED HERE AS A SOURCE PROGRAM.
C
      SUBROUTINE J77(FG,ALG,FM,ATD,ALST,F107,F107C,AK)
C
      REAL Z(75),TN(75),N2(75),O2(75),O(75),AR(75),HE(75),
     *M(75),TO(75),TO2(75),TN2(75),THE(75),TAR(75),
     *O1(75),O21(75),N21(75),HE1(75),AR1(75),H1(75),OO(75),
     *O22(75),N22(75),HE2(75),AR2(75),H(75),RO(75),
     *H2(95),GT(95),KP,LST,NOTH
      COMMON /BL/W,TD,LST,F,F1,KP
      COMMON /BL5D/NOTH,RAD,DELTA,T12,HH/GFI1/FI1
      COMMON /BL2/II/NET/N2,O2,O,TN
      COMMON /BL3/JJ/BKK/NS,Z
      NOTH=FG
      W=ALG
      FI1=FM*0.01745329
      TD=ATD
      LST=ALST
      F=F107
      F1=F107C
      KP=AK
      I=1
      Z(I)=90.
    1 IF(Z(I).GE.1000.) GO TO 2
      S=STEP(Z(I))
      I=I+1
      Z(I)=Z(I-1)+S
      IF(Z(I).EQ.100.) II=I
      IF(Z(I).EQ.500.) JJ=I
      GO TO 1
    2 NS=I
      DELTA=ATAN(0.424*SIN(2.*3.142*(TD-81)/365.))*180./3.142
C======CALCULATION OD CONCENTRATIONS,TEMPERATURE ETC.=======================
    5 CALL MODEL(TN,N2,O2,O,AR,HE,H,NS,RO,M,Z,TO,TO2,TN2,THE,TAR,
     *O1,O21,N21,HE1,AR1,H1,OO,O22,N22,HE2,AR2,H2,GT)
      RETURN
      END
C
      FUNCTION PAR(DPR,DH,NS,H)
      DIMENSION DPR(NS),DH(NS)
      IF (H.EQ.DH(1)) GO TO 5
      DO 1 I=2,NS
      IF ((H.GT.DH(I-1)).AND.(H.LE.DH(I))) GO TO 2
      GO TO 1
    2 IF (H.NE.DH(I)) GO TO 3
      PAR=DPR(I)
      GO TO 4
    3 PAR=DPR(I-1)+(DPR(I)-DPR(I-1))*(H-DH(I-1))/(DH(I)-DH(I-1))
      GO TO 4
    1 CONTINUE
    5 PAR=DPR(1)
    4 RETURN
      END
C
      FUNCTION STEP(H)
C******SELECTION OF HEIGHT STEP*****************************************
      IF(H.LT.2500.) STEP=100.
      IF(H.LT.1500.) STEP=50.
      IF(H.LT.1000.) STEP=20.
      IF(H.LT.400.) STEP=10.
      IF(H.LT.160.) STEP=5.
      IF(H.LT.110.) STEP=2.
      RETURN
      END
C
      SUBROUTINE MODEL(TN,N2,O2,O,AR,HE,H,NS,RO,M,Z,TO,TO2,TN2,THE,
     *TAR,O1,O21,N21,HE1,AR1,H1,OO,O22,N22,HE2,AR2,H2,GT)
C**************   JACCHIA-77  ******************************************
C
      REAL Z(NS),TN(NS),N2(NS),O2(NS),O(NS),H(NS),AR(NS),KP,
     *HE(NS),TO(NS),TO2(NS),TN2(NS),THE(NS),TAR(NS),O1(NS),
     *O21(NS),N21(NS),HE1(NS),AR1(NS),H1(NS),OO(NS),O22(NS),VM(6),
     *N22(NS),HE2(NS),AR2(NS),H2(NS),GT(NS),RO(NS),M(NS),LST,NOTH
      COMMON /BL/W,TD,LST,F,F1,KP/BL5D/NOTH,RAD,DELTA,
     *T12,HH/BL2/II/BL3/JJ/BL1/TT/GFI1/FI1
      DATA PI/3.14159/,VM/28.0134,31.9988,15.9994,39.948,4.0026,1.0079/
      DATA EPS/23.44/
C=======CALCULATION OF RAD,T1/2,S,FI1,HH,FH,TT=============================
      RAD=PI/180.
      T12=5.48*F1**0.8+101.8*F**0.4
C=====S=0.9792*SIN(NOTH*RAD)+0.2028*COS(NOTH*RAD)*COS((W-291.)*RAD)
C=====FI1=ASIN(S)
      HH=(LST-12.)*15
      DN=2.+COS(NOTH*NOTH/90.*RAD)**2
      FH=ABS(COS(0.5*(HH-60.)*RAD))**DN+0.08*COS((3*(HH-60.)-75)*RAD)
      TT=T12*(1+0.15*DELTA/EPS*SIN(NOTH*RAD)+0.24*COS(NOTH*RAD)*
     *(FH-0.5))
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C    IF CALCULATIONS ARE NEEDED FOR STATIC MODEL WITH GIVEN EXOSPHERIC     
C    TEMPERATURE, INSERT HERE TT=T(K)=CONST
C    AND AFTER CALL FOR THE SUBROUTINE AHH REPLACE COMMENT BY:
C    GO TO 12 : THIS IS RETURN FROM THE SUBROUTINE MODEL
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
C===CALCULATION OF TN WITH TB=CONST ===============================================
C
      CALL TMJ(0,TN,NS,Z)
C== CALCULATION OF CONCENTRATION TO 100KM =======================================
      CALL N100(N2,O2,O,AR,HE,TN,NS,Z)
C== CALCULATION OF CORRECTIONS FOR CONCENTRATION O.O2 TO 100KM ======================
C     CALL CORR(O,O2,NS,Z)
C== CALCULATION OF CONCENTRATION ABOVE 100 KM,TB=CONST ============================
      B1=O(II)
      CALL NI(B1,VM(3),0.,TN,O,NS,Z)
      B2=O2(II)
      CALL NI(B2,VM(2),0.,TN,O2,NS,Z)
      CALL CORR(O,O2,NS,Z)
      B3=N2(II)
      CALL NI(B3,VM(1),0.,TN,N2,NS,Z)
      B4=HE(II)
      CALL NI(B4,VM(5),-0.38,TN,HE,NS,Z)
      B5=AR(II)
      CALL NI(B5,VM(4),0.,TN,AR,NS,Z)
      CALL AHH(TN,O,O2,N2,H,HE,AR,NS,Z)
C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C   FOR CALCULATION WITH STATIC MODEL PUT HERE: GO TO 12
C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C== CALCULATION OF PSEUDOTEMPERATURES ============================================
      CALL PTM(16,TO,N2,O2,O,AR,HE,H,NS)
      CALL PTM(32,TO2,N2,O2,O,AR,HE,H,NS)
      CALL PTM(28,TN2,N2,O2,O,AR,HE,H,NS)
      CALL PTM(4,THE,N2,O2,O,AR,HE,H,NS)
      CALL PTM(40,TAR,N2,O2,O,AR,HE,H,NS)
C== CALCULATION TN WITH PROFILES OF PSEUDOTEMPERATURES===========================
      CALL TMJ(1,TO,NS,Z)
      CALL TMJ(1,TO2,NS,Z)
      CALL TMJ(1,TN2,NS,Z)
      CALL TMJ(1,THE,NS,Z)
      CALL TMJ(1,TAR,NS,Z)
C==  CALCULATION OF CONCENTRATION WITH NEW TN ====================================
      CALL N100(N21,O21,O1,AR1,HE1,TN,NS,Z)
      CALL NI(B1,VM(3),0.,TO,O1,NS,Z)
      CALL NI(B2,VM(2),0.,TO2,O21,NS,Z)
      CALL CORR(O1,O21,NS,Z)
      CALL NI(B3,VM(1),0.,TN2,N21,NS,Z)
      CALL NI(B4,VM(5),-0.38,THE,HE1,NS,Z)
      CALL NI(B5,VM(4),0.,TAR,AR1,NS,Z)
      CALL AHH(TN,O1,O21,N21,H1,HE1,AR1,NS,Z)
C==  CALCULATION OF GEOMAGNETIC CORRECTION TO TEMPERATURE
C       AND TEMPERATURE PROFILE ========================================
      A=57.5*(KP+0.01)*(1+0.027*EXP(0.4*KP))
      DGT=A*SIN(FI1)**4
      DO 1 I=1,NS
      X=0.006*(Z(I)-90.)
      GT(I)=DGT*TANH(X)
      TN(I)=TN(I)+GT(I)
    1 CONTINUE
C==  CALCULATION CONCENTRATION WITH CORRECTED
C          TEMPERATURE PROFILE =====================================
      CALL N100(N22,O22,OO,AR2,HE2,TN,NS,Z)
      CALL NI(B1,VM(3),0.,TN,OO,NS,Z)
      CALL NI(B2,VM(2),0.,TN,O22,NS,Z)
      CALL CORR(OO,O22,NS,Z)
      CALL NI(B3,VM(1),0.,TN,N22,NS,Z)
      CALL NI(B4,VM(5),-0.38,TN,HE2,NS,Z)
      CALL NI(B5,VM(4),0.,TN,AR2,NS,Z)
      CALL AHH(TN,OO,O22,N22,H2,HE2,AR2,NS,Z)
C== CALCULATION CONCENTRATION ABOVE 100 KM WITH CORRECTION ON =========
C== GEOMAGNETIC ACTIVITY================================================
      I2=II+1
      DO 2 I=I2,NS
      O(I)=O1(I)+OO(I)-O(I)
      O2(I)=O21(I)+O22(I)-O2(I)
      N2(I)=N21(I)+N22(I)-N2(I)
      H(I)=H1(I)+H2(I)-H(I)
      HE(I)=HE1(I)+HE2(I)-HE(I)
      AR(I)=AR1(I)+AR2(I)-AR(I)
    2 CONTINUE
C== CALCULATION OF CORRECTION ON VARYING HEIGHT OF HOMOPAUSE(B2),==================
C   EQUATORIAL WAVE(E),SESONAL-LATITUDINAL THERMOSPHERE(SL) AND
C   MEZOSPHERE(DSL,DSLT),SEMI-ANNUAL(X)
C ======================================================================
      B2=(TD-1)/365.
      P=SIN(2.*PI*B2+1.72)
      B3=B2+0.0954*((0.5+0.5*SIN(2*PI*B2+6.04))**1.65-0.5)
      E=5.2E-4*A*COS(FI1)**4
      SL=DELTA/EPS*SIN(NOTH*RAD)
      DO 3 I=1,NS
      S=0.
      IF (Z(I).LE.200.) S=0.014*(Z(I)-91.)*EXP(-0.0013*(Z(I)-91.)**2)
      DSL=S*P*(SIN(NOTH*RAD)**2)
      IF (NOTH.LT.0.) DSL=-1.*DSL
      DSLT=0.
      IF (Z(I).LE.200.) DSLT=-2.9*P*(Z(I)-102.5)*EXP(-7.8E-5*
     *ABS(Z(I)-102.5)**2.7)
      B4=(0.04*(Z(I)/100.)**2+0.05)*EXP(-0.25*Z(I)/100.)
      B5=0.0284+0.382*(1+0.467*SIN(2*PI*B3+4.14))*SIN(4*PI*B3+4.26)
      X=B4*B5
      B1=0.01*GT(I)
      B2=5.E+03*ALOG(B1+SQRT(B1*B1+1))
C== CALCULATION OF CORRECTED PROFILES OF CONCENTRATION==========================
      EP=1.E+03
      IF(O2(I).GE.EP) GO TO 4
      O2(I)=0.
      GO TO 5
    4 O2(I)=10.**(ALOG10(O2(I))+1.03E-5*B2+E+X+DSL)
    5 IF(O(I).GE.EP) GO TO 6
      O(I)=0.
      GO TO 7
    6 O(I)=10.**(ALOG10(O(I))-4.85E-5*B2+E-0.16*SL+X+DSL)
    7 IF(N2(I).GE.EP) GO TO 8
      N2(I)=0.
      GO TO 9
    8 N2(I)=10.**(ALOG10(N2(I))+E+X+DSL)
    9 HE(I)=10.**(ALOG10(HE(I))-6.3E-5*B2+E-0.79*SL+X+DSL)
      IF(AR(I).GE.EP) GO TO 10
      AR(I)=0.
      GO TO 11
   10 AR(I)=10.**(ALOG10(AR(I))+3.07E-5*B2+E+X+DSL)
   11 TN(I)=TN(I)+DSLT
    3 CONTINUE
C== CALCULATION OF DENSITY AND MEAN MASS ===================================
   12 DO 13 I=1,NS
      B4=N2(I)+O2(I)+O(I)+AR(I)+HE(I)+H(I)
      B5=N2(I)*VM(1)+O2(I)*VM(2)+O(I)*VM(3)+HE(I)*VM(5)+
     +AR(I)*VM(4)+H(I)*VM(6)
      RO(I)=B5*1.66E-27
      M(I)=B5/B4
   13 CONTINUE
      RETURN
      END
C
      SUBROUTINE CORR(X1,X2,NS,Z)
C** CALCULATION OF CORRECTIONS TO CONCENTRATION O.O2 BELOW 100KM **********************
      REAL Z(NS),X1(NS),X2(NS)
      DO 1 I=1,NS
      X=0.18*(Z(I)-111.)
      S=TANH(X)
      P=-0.009*(Z(I)-97.7)* (Z(I)-97.7)
      IF(ABS(P).GE.174.67) GO TO 2
      P=0.24*EXP(P)
      GO TO 3
    2 P=0.
    3 X1(I)=10.**(ALOG10(X1(I))-P)
      X2(I)=10.**(ALOG10(X2(I))-0.07*(1+S))
    1 CONTINUE
      RETURN
      END
C
      SUBROUTINE TMJ(IND,TK,NS,Z)
C** CALCULATION OF TEMPERATURE PROFILE *****************************************
      REAL Z(NS),TK(NS)
      COMMON /BL1/TT
      DATA PI/3.14159/
      I1=2
      DO 1 I=I1,NS
      IF(IND.EQ.0) TEX=TT
      IF(IND.NE.0) TEX=TK(I)
      X=0.0045*(TEX-188.)
      TX0=110.5*ALOG(X+SQRT(X*X+1))
      TX=188.+TX0
      GX=1.9*TX0/35.
      IF(Z(I).LT.125.) X=GX/TX0*(PI/2.)*(Z(I)-125.)
      IF(Z(I).GE.125.) X=GX/(TEX-TX)*(PI/2.)*(Z(I)-125.)
      IF(Z(I).LT.125.) TK(I)=TX+TX0/PI*2*ATAN(X*(1+1.7*((Z(I)-125.)/
     /(Z(I)-90.))**2))
      IF(Z(I).GE.125.) TK(I)=TX+(TEX-TX)/PI*2*ATAN(X*(1+5.5E-5*(Z(I)-
     -125.)**2))
    1 CONTINUE
      TK(1)=188.
      RETURN
      END
C
      SUBROUTINE NI(N0,MI,AL,TK,NN,NS,Z)
C** CALCULATION OF CONCENTRATION ABOVE 100 KM *************************************
      REAL MI,N0,NN(NS),LN,Z(NS),TK(NS)
      COMMON /BL2/II
      S=0.
      I1=II+1
      DO 1 I=I1,NS
      S=S+(GF(Z(I-1))/TK(I-1)+GF(Z(I))/TK(I))/2.*(Z(I)-Z(I-1))*1000.
      LN=ALOG(N0)-(1+AL)*ALOG(TK(I)/TK(II))-MI/8.31432E+03*S
      NN(I)=EXP(LN)
    1 CONTINUE
      RETURN
      END
C
      SUBROUTINE PTM(MI,PT,N2,O2,O,AR,HE,H,NS)
C** CALCULATION PSEUDOTEMPERATURES******************************************
      REAL N,N2(NS),O2(NS),O(NS),HE(NS),AR(NS),H(NS),M,NOTH,PT(NS)
      COMMON /BL5D/NOTH,RAD,DELTA,T12,HH
      N=2+COS(NOTH*NOTH/90.*RAD)**2
      DO 1 I=1,NS
      S=O(I)*16.+O2(I)*32.+N2(I)*28.+H(I)+HE(I)*4+AR(I)*40.
      S1=O(I)+O2(I)+N2(I)+H(I)+HE(I)+AR(I)
      M=S/S1
      BT=-35+27*(M/MI-1.)
      FH=ABS(COS(0.5*(HH+BT)*RAD))**N+0.08*COS((3*(HH+BT)-75)*RAD)
      PT(I)=T12*(1+0.15*DELTA/23.44*SIN(NOTH*RAD)+0.24*COS(NOTH*
     *RAD)*(FH-0.5))
    1 CONTINUE
      RETURN
      END
C
      SUBROUTINE N100(N2,O2,O,AR,HE,TK,NS,Z)
C** CALCULATION OF CONCENTRATION BELOW 100 KM ***************************************
      REAL TK(NS),O(NS),O2(NS),N2(NS),AR(NS),HE(NS),Z(NS)
      COMMON /BL2/II
      CM=28.89122
      S=0.
      DO 1 I=1,II
      IF(I.EQ.1) GO TO 3
      CM=U(Z(I))
      G=GF(Z(I))
      S=S+(U(Z(I-1))*GF(Z(I-1))/TK(I-1)+CM*G/TK(I))/2.*
     *(Z(I)-Z(I-1))*1000.
    2 RO=ALOG(3.43E-6)+ALOG(CM*TK(1)/TK(I)/28.89122)-1./8.31432E3*S
      RO=EXP(RO)
      GO TO 5
    3 RO=3.43E-6
    5 SN=6.02217E+26*RO/CM
      X=CM/28.96
      O(I)=2.*SN*(1-X)
      O2(I)=SN*(X*(1+0.20955)-1)
      N2(I)=0.7811*SN*X
      AR(I)=0.009343*SN*X
      HE(I)=0.000005242*SN*X
    1 CONTINUE
      RETURN
      END
C
      SUBROUTINE AHH(TK,X1,X2,X3,X4,X5,X6,NS,Z)
C** CALCULATION OF HYDROGEN CONCENTRATION ***************************************
      REAL TK(NS),X1(NS),X2(NS),X3(NS),X4(NS),X5(NS),X6(NS),NJ,Z(NS)
      COMMON /BL3/JJ/BL1/TT/BL7/FXY0,ZN,TA,HEH
    2 X=TT
      X4(JJ)=10.**(5.94+28.9*X**(-0.25))
      FH=10.**(6.9+28.9*X**(-0.25))
      I=JJ+1
      J2=NS
      J3=1
    5 IF(I.EQ.J2+J3) GO TO 3
      IF(J3.EQ.1) GO TO 6
      K1=I
      K2=I-1
      K10=JJ
      K20=JJ
      GO TO 7
    6 K1=I-1
      K2=I
      K10=K1
      K20=K2
    7 SM1=X1(K10)+X2(K10)+X3(K10)+X5(K10)+X6(K10)
      DER=DERI(TK,Z,K1,NS)
      CALL CFXY(TK(K1),DER,Z(K1),SM1,FH,FC1,FC2)
      FXY0=X4(K1)*FC1-FC2
      SM=X1(K20)+X2(K20)+X3(K20)+X5(K20)+X6(K20)
      DER=DERI(TK,Z,K2,NS)
      CALL CFXY(TK(K2),DER,Z(K2),SM,FH,FC1,FC2)
      TA=FC1
      ZN=FC2
      NJ=X4(K1)
      HEH=(Z(K2)-Z(K1))*1.E+03
      X4(K2)=ROK(NJ)
      I=I+J3
      GO TO 5
    3 CONTINUE
      IF(J3.EQ.-1) GO TO 4
      I=JJ
      J2=2
      J3=-1
      GO TO 5
    4 CONTINUE
      RETURN
      END
C
      FUNCTION ROK(ROJ)
C** SOLUTION OF DIFFERENTIAL EQUATION WITH ALER  METHOS
      COMMON /BL7/FXY0,ZN,TA,HEH
      ROK=(ROJ+HEH/2*(FXY0-ZN))/(1.-TA*HEH/2)
    2 RETURN
      END
C
      FUNCTION GF(Z)
C** CALCULATION OF FUNCTION G ***************************************************
      DATA GG/9.80665/,RE/6.356766E+03/
      GF=GG*(1+Z/RE)**(-2)
      RETURN
      END
C
      SUBROUTINE CFXY(TK,DER,Z,SM,FH,FC1,FC2)
C** CALCULATION OF COEFFICIENTS OF DIFFERENTIAL EQUATION *******************
      H=8.31432E+03*TK/1.0079/GF(Z)
      TA=-1./H
      IF(ABS(DER).GT.1.E-30) TA=TA-DER*0.75/TK
      D=2.E+20*SQRT(TK)/SM
      FC1=TA-FH/2.E+20/SQRT(TK)
      FC2=FH/D
      RETURN
      END
C
      FUNCTION DERI(TK,Z,I,NS)
C** CALCULATION OF DERIVATIVE*******************************************
      DIMENSION TK(NS),Z(NS)
      IF(I.EQ.1)GO TO 3
      IF(I.EQ.NS)GO TO 1
      DERI=(TK(I+1)-TK(I-1))/((Z(I+1)-Z(I-1))*1.E+03)
      GO TO 2
    1 DERI=(TK(I)-TK(I-1))/((Z(I)-Z(I-1))*1.E+03)
      GO TO 2
    3 DERI=(TK(I+1)-TK(I))/(Z(I+1)-Z(I))/1.E+3
    2 RETURN
      END
C
      FUNCTION U(Z)
      REAL C(5)
      DATA C/-2.83071E-2,-6.59924E-3,-3.39574E-4,6.19256E-5,-1.84796E-6/
      U=28.89122
      DO 1 J=1,5
      U=U+C(J)*(Z-90.)**J
    1 CONTINUE
      RETURN
      END
C **********************************************************************
