C
C      8. OPOPAMM, PACCTBAE APAMETP MAKCMMA
C                         CO F2
C
      REAL FUNCTION HF2OUT(XMODIP,XLATI,XLONGI,XMAGBR,XR,HOUR,FOE,FOF2,
     &DAY,XMLAT,XM3000)
      DIMENSION MQM(7),XMM0(441),FM3N(9,49,2),FM3S(9,49,2)
      COMMON /BLOKB/FM3N,FM3S
      DATA MQM/6,7,5,2,1,0,0/
      R=200.*XR/(XR**8+2.56E18)**0.125
      ABML=ABS(XMLAT)
      YLATI=ABS(XLATI)
      IF ((XLATI.GE.0.).OR.((XMLAT+11.4).GE.0.)) GO TO 15
      DO 10 I=1,49
      DO 10 J=1,9
      K=J+9*(I-1)
   10 XMM0(K)=(FM3S(J,I,1)*(100.0-R)+FM3S(J,I,2)*R)/100.0
      XM3000=GAMMA1(XMODIP,YLATI,XLONGI,.FALSE.,HOUR,4,MQM,7,49,9,441,
     *XMM0)
      GO TO 30
   15 CONTINUE
      DO 20 I=1,49
      DO 20 J=1,9
      K=J+9*(I-1)
   20 XMM0(K)=(FM3N(J,I,1)*(100.0-R)+FM3N(J,I,2)*R)/100.0
      XM3000=GAMMA1(XMODIP,XLATI,XLONGI,.FALSE.,HOUR,4,MQM,7,49,9,441,
     *XMM0)
   30 HF2OUT=HMF2ED(XMAGBR,R,FOF2/FOE,XM3000,HOUR,DAY,ABML)
      RETURN
      END
C
      SUBROUTINE CCIRCA(IMONTH)
C     OPOPAMMA PACCTBAET KOEHT POB PAOEH
C     FOF2(76,13)  SM3000(49,9)  AAHHX HEKCA COHE-
C     HO AKTBHOCT R  MECA, CO CEAH MAHT-
C     H EHT MKKP(CCIR).
      DIMENSION F2(13,76,2),FM3N(9,49,2),FM3S(9,49,2)
      COMMON /BLOKA/F2/BLOKB/FM3N,FM3S
      MON=IMONTH+6
      IF (MON.GT.12) MON=MON-12
      READ (16,rec=mon) F2,FM3S
      REWIND 16
      READ (16,rec=imonth) F2,FM3N
      REWIND 16
      RETURN
      END
C
      REAL FUNCTION HMF2ED(XMAGBR,R,X,XM3,HOUR,DAY,ABML)
C     D. BILITZA,PACET BCOT MAKCMMA OACT F(HMF2)  AAH-
C     HX MAHTHO POT (XMAGBR)  CA COHEHX TEH (R) C
C     COOBAHEM KOEHTA M3000(XM3)  OTHOEH FOF2/FOE.
C     [CM. D. BILITZA ET. AL. TELECOMM.J.,46,549-553,1979]
      COMMON /BLO11/XHI/B6/HMLAT,H0NE,GLT,FG1,FG2
      F1=(2.32E-3)*R+0.222
      F2=1.2-(1.16E-2)*EXP((2.39E-2)*R)
      F3=0.096*(R-25.0)/150.0
      XMIN=1.7
      IF (ABS(HMLAT).LT.64.) GO TO 1
      XZ=(XHI-65.)/6.
      XZ1=XZ*XZ
      XZ1=XZ1*XZ1
      RBA=(XZ1+16.)**0.25
      RB=0.25*XZ/RBA+1.95
      XZ=(XHI-74.)/6.
      XZ1=XZ*XZ
      XZ1=XZ1*XZ1
      RHA=(XZ1+16.)**0.25
      RH=0.2*XZ/RHA+1.70
      XMIN=(RB-RH)*(R-10.)/140.+RH
    1 IF (X.LT.XMIN) X=XMIN
      DELM=F1*(1.0-R/150.0*EXP(-XMAGBR*XMAGBR/1600.0))/(X-F2)+F3
      HMF2ED=1490./(XM3+DELM)-176.
      IF (ABML.LT.30.) HMF2ED=HMF2ED*DELH(HOUR,DAY,ABML)
      RETURN
      END
C
      FUNCTION DELH(ALST,TD,AFI)
      TD1=TD-14.
      IF(TD1.LE.0.) TD1=TD1+365.
      YD=(TD1+29.5)/30.5
      Y=YD
      IF(Y.GT.6.5)Y=13-Y
      A1=0.02+ZFUN(1.,-1.,(Y-2.9)/1.1)/8.+0.18*EFUN(Y,2.,0.6,2)
      A2=ZFUN(0.07,0.18,(YD-1.)/1.2)-ZFUN(1.,1.,(YD-13.)/0.6)*0.18
      A2=A2-0.08*EFUN(YD,9.,4.-YD/6.,2)
      A3=ZFUN(0.09,0.28,YD-1)-0.28*ZFUN(1.,1.,YD-13)
      A3=A3-0.26*EFUN(YD,7.7,2.7,2)-0.05*EFUN(YD,3.,0.5,2)
      A4=ZFUN(.14,-.12,(YD-3.7)/0.6)+ZFUN(1.,1.,(YD-10.1)/.4)*0.12
      A4=A4-ZFUN(1.,-1.,(Y-1.3)*5)*0.11+EFUN(YD,6.8,1.,2)/10.
      DELH=0.98+A1*EFUN(ALST,0.,1.8,2)+A2*EFUN(ALST,5.2,1.4,2)
      DELH=DELH-(0.6*A3+0.4*A1-A4)*EFUN(ALST,21.,1.3,2)
      DELH=DELH+(5.*A3+(A1-A3)*(ALST-19.))*
     1     ZFUN(1.,1.,(ALST-17.7)/0.6)/10.
      DELH=DELH+(1-DELH)*AFI**2*(90.-2.*AFI)/27000.
      RETURN
      END
C
      REAL FUNCTION F2OUT(XMODIP,XLATI,XLONGI,R,HOUR)
C     D.BILITZA,20.8.78. PACET XHMF2  NMF2 C COOBAHEM
C     KAPT MKKP(CCIR)  FOF2  M3000.
      DIMENSION FF0(988),MQF(9),F2(13,76,2)
      COMMON /BLOKA/F2
      DATA MQF/11,11,8,4,1,0,0,0,0/
      DO 20 I=1,76
      DO 20 J=1,13
      K=J+13*(I-1)
   20 FF0(K)=(F2(J,I,1)*(100.0-R)+F2(J,I,2)*R)/100.0
      F2OUT=GAMMA1(XMODIP,XLATI,XLONGI,.FALSE.,HOUR,6,MQF,9,76,13,988,
     &FF0)
      RETURN
      END
C
      REAL FUNCTION F2NW(DAY,XMLAT,HOUR,XLATI,XLONGI,XMODIP,R)
      DIMENSION FG(2),D(2)
      RNAS=RN(DAY,XMLAT)
      IF (R.LE.RNAS) GO TO 2
      CALL FCOR(DAY,HOUR,FG)
      IF ((XMLAT.LT.(FG(1)-10.)).OR.(XMLAT.GT.(FG(2)+10.))) GO TO 2
      IF ((XMLAT.GT.(FG(1)+10.)).AND.(XMLAT.LT.(FG(2)-10.))) GO TO 1
      FMAX=F2OUT(XMODIP,XLATI,XLONGI,R,HOUR)
      FNAS=F2OUT(XMODIP,XLATI,XLONGI,RNAS,HOUR)
      DO 3 I=1,2
    3 D(I)=1.+EXP((FG(I)-XMLAT)/2.)
      F2NW=FMAX-(FMAX-FNAS)/D(1)+(FMAX-FNAS)/D(2)
      RETURN
    1 F2NW=F2OUT(XMODIP,XLATI,XLONGI,RNAS,HOUR)
      RETURN
    2 F2NW=F2OUT(XMODIP,XLATI,XLONGI,R,HOUR)
      RETURN
      END
C
      SUBROUTINE FCOR(DAY,HOUR,FGR)
      DIMENSION FWIN(25),FEQ(25),FSUM(25),FGR(2)
      DATA FWIN /7.,2.,4*0.,2.,7.,10.,15.,18.,20.,24.,25.,24.,22.,20.,
     115.,12.,11.,10.,9.,8.,2*7./, FEQ /60.,62.,65.,67.,69.,70.,73.,
     274.,4*75.,74.,72.,71.,70.,69.,67.,66.,65.,64.,62.,3*60./, FSUM
     3/-20.,-20.,-20.,-20.,-20.,-22.,-24.,-26.,-30.,-35.,-40.,-45.,-49.
     4,-50.,-50.,-46.,-40.,-35.,-30.,-24.,-20.,-15.,-15.,-17.,-20./
      IF ((DAY.LE.31.).OR.(DAY.GE.335.)) CALL SEAS(FWIN,HOUR,-68.,
     *130.,FGR)
      IF ((DAY.GT.31.).AND.(DAY.LT.90.)) CALL SEASM (FWIN,FEQ,HOUR,
     *-68.,130.,-49.,130.,DAY,FGR)
      IF ((DAY.EQ.90.).OR.(DAY.EQ.273.)) CALL SEAS (FEQ,HOUR,49.,130.,
     *FGR)
      IF ((DAY.GT.90.).AND.(DAY.LT.152.)) CALL SEASM (FEQ,FSUM,HOUR,
     *-49.,130.,130.,90.,DAY,FGR)
      IF ((DAY.GE.152.).AND.(DAY.LE.212.)) CALL SEAS(FSUM,HOUR,130.,
     *110.,FGR)
      IF ((DAY.GT.212.).AND.(DAY.LT.273.)) CALL SEASM (FSUM,FEQ,HOUR,
     *130.,90.,-49.,130.,DAY,FGR)
      IF ((DAY.GT.273.).AND.(DAY.LT.335.)) CALL SEASM (FEQ,FWIN,HOUR,
     *-49.,130.,-68.,130.,DAY,FGR)
      RETURN
      END
C
      SUBROUTINE SEAS (FMAS,HOUR,FGR1,FGR2,FGR)
      DIMENSION FMAS(25),FGR(2)
      IHOUR=IFIX(HOUR)
      FGR(1)=FGR1
      FGR(2)=FGR2
      I=2
      IF (FGR(2).LT.130.) I=1
      FGR(I)=FMAS(IHOUR+1)+(FMAS(IHOUR+2)-FMAS(IHOUR+1))*(HOUR-IHOUR)
      RETURN
      END
C
      SUBROUTINE SEASM(FMAS1,FMAS2,H,FGR1,FGR2,GR1,GR2,DAY,FGR)
      DIMENSION FMAS1(25),FMAS2(25),FM1(2),FM2(2),FGR(2)
      IH=IFIX(H)
      FM1(1)=FGR1
      FM1(2)=FGR2
      FM2(1)=GR1
      FM2(2)=GR2
      I=2
      IF (FM1(2).LT.130.) I=1
      FM1(I)=FMAS1(IH+1)+(FMAS1(IH+2)-FMAS1(IH+1))*(H-IH)
      K=2
      IF (FM2(2).LT.130.) K=1
      FM2(K)=FMAS2(IH+1)+(FMAS2(IH+2)-FMAS2(IH+1))*(H-IH)
      FK=SPRN(DAY)
      DO 1 I=1,2
    1 FGR(I)=FM1(I)+(FM2(I)-FM1(I))*FK
      RETURN
      END
C
      REAL FUNCTION RN(TD,FI)
      REAL A(3,4),A0(4)
      DATA A/124.,137.5,160.,22.,7.5,10.,-20.,-5.,-15.,14.,10.,6./
      DO 1 I=1,4
      SLG=(A(2,I)-A(1,I))*ZFUN(1.,1.,(TD-53.)/10.)
      SLG=SLG+(A(3,I)-A(2,I))*ZFUN(1.,1.,(TD-235.)/10.)
      A0(I)=A(1,I)+(SLG+(A(1,I)-A(3,I))*ZFUN(1.,1.,(TD-312.)/10.))/2.
    1 CONTINUE
      RN=ZFUN(A0(1),A0(2),(FI-A0(3))/A0(4))
      RETURN
      END
C
      REAL FUNCTION SPRN(DNR)
      SPRN=0
      IF ((DNR.GT.31.).AND.(DNR.LT.90.)) SPRN=(DNR-31.)/59.
      IF ((DNR.GT.90.).AND.(DNR.LT.152.)) SPRN=(DNR-90.)/62.
      IF ((DNR.GT.212.).AND.(DNR.LT.273.)) SPRN=(DNR-212.)/61.
      IF ((DNR.GT.273.).AND.(DNR.LT.335.)) SPRN=(DNR-273.)/62.
      RETURN
      END
C
      SUBROUTINE F0F2AN(FM0,LAT0,LONG0,TD0,UT0,RC,F107C,KP,KP1,F0F2)
C
C______ PACET KPTECKO ACTOT CO F2 __________________________
C          HA EOMAHTHX POTAX
C                40-80 PACOB
      INTEGER TD,TD1
      REAL LATI,LONGI,KP,M,K,KP1,KPP,LAT0,LONG0
      FM=ABS(FM0)
      LATI=ABS(LAT0)
      LONGI=LONG0
      TD2=TD0
      UT=UT0
         IF(FM0.GE.0.) GO TO 583
      LONGI=LONGI+180.
      IF(LONGI.GE.360.) LONGI=LONGI-360.
      TD2=TD2+183.
      IF(TD2.GE.366.) TD2=TD2-365.
      UT=UT+12.
      IF(UT.GE.24.) UT=UT-24.
  583 CONTINUE
      KPP=KP
      IF(KP1.GT.KP) KPP=KP1
       TD=INT(TD2)
      XHI0=LATI-ATAN(0.43*SIN(2*3.1416*(TD-81)/365.))*180./3.1416
      TD1=TD-15
        IF(TD1.LE.0) TD1=TD1+365
      CALL FACTOM(TD1,LATI,LONGI,M,N1,N2)
      CALL F0F20(F107C,RC,XHI0,M,TD1,N1,N2,F0F2,FM0)
      CALL COEFK(F107C,TD,KPP,FM,LATI,LONGI,UT,K)
      F0F2=F0F2*K
      RETURN
      END
C
      SUBROUTINE F0F20(F107C,RC,XZU,M,TD1,N1,N2,F0F2,FM0)
      REAL N,M
      REAL AK(12),BK(12),CK(12),DK(12)
      INTEGER TD1
      DATA AK/5.9,6.1,7.3,6.7,6.6,6.1,6.,6.,6.3,7.8,6.9,6.7/,
     *BK/2.78,2.88,2.17,2.61,2.07,1.96,1.94,2.07,2.38,1.87,2.43,2.31/,
     *CK/0.42,0.46,0.66,0.6,0.53,0.47,0.37,0.45,0.59,0.6,0.5,0.48/,
     *DK/-0.46E-3,-0.35E-3,-0.81E-3,1.43E-3,1.91E-3,3.4E-3,3.5E-3,
     *2.2E-3,0.8E-3,-1.2E-3,-1.1E-3,-0.98E-3/
      ZU=XZU
      IF (ZU.GT.99.0) ZU=99.0
      ST=(TD1-N1)*1./(N2-N1)
      L1=INT(N1/30.)+1
      L2=INT(N2/30.)+1
      IF(L2.GT.12) L2=1
         L1A=L1
         L2A=L2
         IF(FM0.GE.0.) GO TO 500
         L1A=L1+6
         L2A=L2+6
         IF(L1A.GT.12) L1A=L1A-12
         IF(L2A.GT.12) L2A=L2A-12
  500 AI=AK(L1A)+(AK(L2A)-AK(L1A))*ST
      BI=BK(L1A)+(BK(L2A)-BK(L1A))*ST
      CI=CK(L1)+(CK(L2)-CK(L1))*ST
      DI=DK(L1)+(DK(L2)-DK(L1))*ST
      A=AI+BI*AI*(ALOG10(F107C)-1.812)
      N=CI+DI*RC
      IF(ZU.LE.65.) FZU=1/COS(ZU*1.745E-2)
      IF(ZU.GT.65.) FZU=FCH(ZU)
      F0F2=A/FZU**N*M
      RETURN
      END
C
      SUBROUTINE COEFK(F107,TD1,KP,FM,FG,LM,UT,K)
      REAL KP,LM,K1,K2,K,LM1
      INTEGER N(8),TD1
      COMMON /BK/NBLOK/COR/FG1,FM1,LM1,UT1
      DATA N/32,60,91,135,213,244,274,319/
      FG1=FG
      FM1=FM
      LM1=LM
      UT1=UT
      NBLOK=0
      ALM=UT+LM1/15.
      IF (ALM.GE.24.) ALM=ALM-24.0
      ISE1=1
      IF ((TD1.LE.32).OR.(TD1.GE.319)) GO TO 6
      DO 1 I=2,8,2
      IF (TD1.GT.N(I)) GO TO 1
      ISE1=I/2
      IF (TD1.LE.N(I-1)) GO TO 6
      IF(I.GT.6) GO TO 2
      ISE2=I/2+1
      NUM1=N(I-1)
      NUM2=N(I)
      GO TO 4
    2 ISE1=1
      ISE2=4
      NUM1=N(I)
      NUM2=N(I-1)
    1 CONTINUE
    4 CALL SKSA(ISE1,F107,KP,K1)
      CALL SKSA(ISE2,F107,KP,K2)
      IF (ISE1.NE.1) GO TO 5
      CALL CORK(FM1,ALM,KP,K1)
    5 K=K1+(K2-K1)/(NUM2-NUM1)*(TD1-NUM1)
      GO TO 7
    6 CALL SKSA(ISE1,F107,KP,K)
      IF (ISE1.EQ.1) CALL CORK(FM1,ALM,KP,K)
    7 RETURN
      END
C
      SUBROUTINE SKSA(ISE,F107,KP,KSA)
      REAL KP,KSA,KSA1,KSA2
      IF (ISE.EQ.1.AND.KP.LE.4) GO TO 1
      CALL SKGA(ISE,2,KP,KSA)
      GO TO 2
    1 CALL SKGA(ISE,1,KP,KSA1)
      CALL SKGA(ISE,2,KP,KSA2)
      IF(F107.LE.90.) GO TO 3
      IF(F107.GE.200.) GO TO 4
      KSA=KSA1+(KSA2-KSA1)/110.*(F107-90.)
      GO TO 2
    3 KSA=KSA1
      GO TO 2
    4 KSA=KSA2
    2 RETURN
      END
C
      SUBROUTINE SKGA(ISE,ISA,KP,KGA)
      REAL KP,KGA
      IF(KP.GT.4.) GO TO 4
      IF(KP.GE.2.) GO TO 1
      IGA=1
      GO TO 6
    1 IGA=2
      GO TO 6
    4 IGA=3
    6 CALL SKUT(ISE,ISA,IGA,KGA)
    7 RETURN
      END
C
      SUBROUTINE SKUT (ISE,ISA,IGA,KU)
      INTEGER IS(14)
      REAL KU,KF(11,48),kfm(11,48,14)
      COMMON /BK/NBLOK/akfm/kfm
      DATA IS/111,112,121,122,123,221,222,223,321,322,323,421,422,423/
      ISV=ISE*100+ISA*10+IGA
    1 NBLOK=NBLOK+1
      IF(NBLOK.LE.14) GO TO 2
      WRITE (*,103) ISV
  103 FORMAT(10X,'TAA KOEHTOB K HE HAEHA'/10X,I4)
      KU=0.5
      return
    2 IF(ISV.NE.IS(NBLOK)) GO TO 1
      do 3 j=1,48
      do 3 i=1,11
    3 kf(i,j)=kfm(i,j,nblok)
      CALL SBLOK(KF,KU)
      RETURN
      END
C
      SUBROUTINE SBLOK(KF,KUT)
      REAL LMP,KIJ,KI1,K11,K1J
      REAL LM,LM1,LM2,LT,LMT(12),FTM(11),FTG(11),FT(11),KF(11,48)
      REAL KU(2),KUT
      COMMON /COR/FG,FM,LM,UT/BK/NBLOK
      DATA FTM/70.,68.,66.,64.,62.,60.,58.,56.,54.,52.,50./,
     *FTG/75.,70.,65.,60.,55.,50.,45.,40.,35.,30.,25./,
     *LMT/0.,30.,60.,90.,120.,150.,180.,210.,240.,270.,300.,330./
      DO 1 I=1,4
      IP=I-1
      UT2=6.0*I
      IF (UT.LE.UT2) GO TO 2
    1 CONTINUE
    2 UT1=UT2-6.0
      LT=UT+LM/15
      IF(LT.GE.24.) LT=LT-24.
      LM1=15*(LT-UT1)
      IF(LM1.LT.0.) LM1=360.+LM1
      LM2=15*(LT-UT2)
      IF (LM2.LT.0.) LM2=360.+LM2
      IF (NBLOK.GE.9.AND.NBLOK.LE.11) GO TO 4
      I1=1
      IF ((FM.GT.80.0).OR.(FM.LT.40.0)) GO TO 6
      DO 8 I=1,11
    8 FT(I)=FTM(I)
      FI=FM
      II=11
      GO TO 10
    4 I1=2
      IF (FG.GT.80.0) FG=80.0
      IF (FG.LT.25.0) FG=25.0
      DO 9 I=1,11
    9 FT(I)=FTG(I)
      FI=FG
      II=9
   10 IF ((FI.LE.FT(1)).AND.(FI.GE.FT(II))) GO TO 14
      I2=1
      I=1
      IF (FI.LT.FT(II)) I=II
      GO TO 150
   14 I2=2
      I=1
   16 I=I+1
      IF(FI.LE.FT(I)) GO TO 16
  150 L=1
      LMP=LM1
      UTP=UT1
   15 J=1
      IF(LMP.LE.330.) GO TO 17
      J2=12*(IP+L)+1
      J1=12*(IP+L-1)+1
      J=13
      GO TO 22
   17 J=J+1
      J1=12*(IP+L-1)+J
      IF(LMP.GT.LMT(J)) GO TO 17
      J2=J1
   22 IF(I2.EQ.2) GO TO 18
      KIJ=EXTRKF(KF,I,J1)
      KI1=EXTRKF(KF,I,J2-1)
      KU(L)=KI1+(KIJ-KI1)/30.*(LMP-LMT(J-1))
      GO TO 19
   18 AL=(FI-FT(I-1))/(FT(I)-FT(I-1))
      BETA=(LMP-LMT(J-1))/30.
      K11=EXTRKF(KF,I-1,J2-1)
      KI1=EXTRKF(KF,I,J2-1)
      K1J=EXTRKF(KF,I-1,J1)
      KIJ=EXTRKF(KF,I,J1)
      KU(L)=K11+AL*(KI1-K11)+BETA*(K1J-K11)+AL*BETA*(KIJ-KI1-K1J+K11)
   19 IF (ABS(UT-UTP).LE.2.0) GO TO 3
      IF (IP.EQ.3) IP=-1
      IF (L.EQ.2) GO TO 20
      L=2
      LMP=LM2
      UTP=UT2
      GO TO 15
   20 KUT=KU(1)+(KU(2)-KU(1))/2.0*(UT-UT1-2.0)
      GO TO 6
    3 KUT=KU(L)
    6 RETURN
      END
C
      FUNCTION EXTRKF(KF,I,J)
      REAL KF(11,48)
      IT=I
    3 IF(KF(IT,J).LE.0.015) GO TO 1
      EXTRKF=KF(IT,J)
      GO TO 2
    1 IT=IT+1
      GO TO 3
    2 RETURN
      END
C
      SUBROUTINE CORK(FT,LT,KP,K)
C-----OPABKA  K-TA  K-------------------------------------------------
C-----MA--------------------------------------------------------------
C-----POBA------------------------------------------------------------
      REAL LT,KP,K
      IF((LT.GT.3.5).AND.(LT.LT.16.5)) RETURN
      IF (LT.GE.12.) GO TO 11
      T2=LT
      GO TO 12
  11  T2=LT-24.
  12  F0=65.2-2.1*KP-0.5*T2
      F=FT-F0
      IF((F.GE.9.).OR.(F.LE.-3.)) RETURN
      C18=(0.09+0.05*COS(0.314*(F-1.5)))*(1.+COS(1.26*(F-1.7)))+0.33
      C20=ZFUN(0.42,0.22,(F-4.)/1.1)+ZFUN(0.08,-0.08,F/0.9)
      C20=C20-0.17*EXP(-(F-6.7)**2)
      C22=ZFUN(0.31,0.11,F-2.5)+ZFUN(0.06,-0.06,(F+1.7)*2)
      C22=C22+0.22*EXP(-((F-7.5)/2.)**2)
      IF(KP.LE.2.) GO TO 1
      C22=C22+0.17*EXP(-((F-2.)/1.)**2)
   1  C00=0.24*SIN(0.365*(F-4.))+0.41
      IF(KP.LE.2.) GO TO 2
      C00=C00+ZFUN(0.13,0.13,(F-0.5)*4)*ZFUN(0.5,-0.5,(F-2.2)/0.6)
   2  C02=ZFUN(0.41,0.23,(F-5.0)/1.6)+ZFUN(0.04,-0.04,F+1.5)
      IF (KP.LE.2.) GO TO 3
      C02=C02+ZFUN(0.08,0.08,(F-3.)*2)*ZFUN(0.5,-0.5,(F-5.2)/0.4)
   3  IF(LT.LE.3.) GO TO 6
      IF(LT.GE.20.) GO TO 4
      C1=C18
      C2=C20
      T=18.
      GO TO 7
   4  IF(LT.GE.22.) GO TO 5
      C1=C20
      C2=C22
      T=20.
      GO TO 7
   5  C1=C22
      C2=C00
      T=22.
      GO TO 7
   6  C1=C00
      C2=C02
      T=0.0
   7  C=C1+(LT-T)*(C2-C1)/2.
      A=ZFUN(1.,-1.,(F-7.)*2.)*ZFUN(1.,1.,(F+2.)*2.)
      A=A*ZFUN(1.,-1.,(T2-2.75)*4.)*ZFUN(1.,1.,(T2+6.75)*4.)/16.
      K=C*A+K*(1-A)
      RETURN
      END
C
      FUNCTION FCH(ZU)
      VS=100.
      ZK=1.745E-2
      Y=SQRT(0.5*VS)*ABS(COS(ZU*ZK))
      IF(ZU-90.) 1,1,2
    1 FCH=SQRT(3.14159/2*VS)*EXP(Y**2)*ERFC(Y)
      GO TO 3
    2 A=VS*(1-SIN(ZU*ZK))
      A=SQRT(SIN(ZU*ZK))*EXP(A)
      A=A-0.5*EXP(Y**2)*ERFC(Y)
      FCH=A*SQRT(2*3.14159*VS)
    3 RETURN
      END
C
      REAL FUNCTION ERFC(Y)
C                                  SPECIFICATIONS FOR ARGUMENTS
      REAL               Y
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            ISW,I
      DIMENSION          P(3),Q(2),P1(5),Q1(4),P2(3),Q2(2)
      REAL               P,Q,P1,Q1,P2,Q2,XMIN,XLARGE,SQRPI,X,
     *                   RES,XSQ,XNUM,XDEN,XI,XBIG
C                                  COEFFICIENTS FOR 0.0 .LE. Y .LT.
C                                  .477
      DATA               P(1)/.3166529/,P(2)/1.722276/,
     *                   P(3)/21.38533/
      DATA               Q(1)/7.843746/,Q(2)/18.95226/
C                                  COEFFICIENTS FOR .477 .LE. Y
C                                  .LE. 4.0
      DATA               P1(1)/.5631696/,P1(2)/3.031799/,
     *                   P1(3)/6.865018/,P1(4)/7.373888/,
     *                   P1(5)/4.318779E-5/
      DATA               Q1(1)/5.354217/,Q1(2)/12.79553/,
     *                   Q1(3)/15.18491/,Q1(4)/7.373961/
C                                  COEFFICIENTS FOR 4.0 .LT. Y
      DATA               P2(1)/-5.168823E-2/,P2(2)/-.1960690/,
     *                   P2(3)/-4.257996E-2/
      DATA               Q2(1)/.9214524/,Q2(2)/.1509421/
C                                  CONSTANTS
      DATA               XMIN/1.0E-5/,XLARGE/4.1875E0/
C                                  ERFC(XBIG) .APPROX. SETAP
      DATA               XBIG/9.0/
      DATA               SQRPI/.5641896/
C                                  FIRST EXECUTABLE STATEMENT
      X = Y
      ISW = 1
      IF (X.GE.0.0E0) GO TO 5
      ISW = -1
      X = -X
    5 IF (X.LT..477E0) GO TO 10
      IF (X.LE.4.0E0) GO TO 25
      IF (ISW .GT. 0) GO TO 35
      IF (X.LT.XLARGE) GO TO 40
      RES = 2.0E0
      GO TO 55
C                                  ABS(Y) .LT. .477, EVALUATE
C                                  APPROXIMATION FOR ERFC
   10 IF (X.LT.XMIN) GO TO 15
      XSQ = X*X
      XNUM = (P(1)*XSQ+P(2))*XSQ+P(3)
      XDEN = (XSQ+Q(1))*XSQ+Q(2)
      RES = X*XNUM/XDEN
      GO TO 20
   15 RES = X*P(3)/Q(2)
   20 IF (ISW.EQ.-1) RES = -RES
      RES = 1.0E0-RES
      GO TO 55
C                                  .477 .LE. ABS(Y) .LE. 4.0
C                                  EVALUATE APPROXIMATION FOR ERFC
   25 XSQ = X*X
      XNUM = P1(5)*X+P1(1)
      XDEN = X+Q1(1)
      DO 30 I=2,4
         XNUM = XNUM*X+P1(I)
         XDEN = XDEN*X+Q1(I)
   30 CONTINUE
      RES = XNUM/XDEN
      GO TO 45
C                                  4.0 .LT. ABS(Y), EVALUATE
C                                  MINIMAX APPROXIMATION FOR ERFC
   35 IF (X.GT.XBIG) GO TO 50
   40 XSQ = X*X
      XI = 1.0E0/XSQ
      XNUM = (P2(1)*XI+P2(2))*XI+P2(3)
      XDEN = (XI+Q2(1))*XI+Q2(2)
      RES = (SQRPI+XI*XNUM/XDEN)/X
   45 RES = RES*EXP(-XSQ)
      IF (ISW.EQ.-1) RES = 2.0E0-RES
      GO TO 55
   50 RES = 0.0E0
   55 ERFC = RES
      RETURN
      END
C
      SUBROUTINE FACTOM(TD1,FI,LM,M,N1,N2)
      INTEGER ID(12),TD1
      REAL M,M1,M2,LM,LM1
      COMMON /A/FI1,LM1
      DATA ID/1,32,60,91,121,152,182,213,244,274,305,335/
      FI1=FI
      LM1=LM
      NT=0
    1 NT=NT+1
      IF(TD1.LT.ID(NT)) GO TO 2
      IF(TD1.LT.ID(12)) GO TO 1
      CALL INM(nt,M2)
      N1=ID(12)
      N2=ID(12)+31
      CALL INM(12,M1)
      GO TO 3
    2 CALL INM(nt-1,M1)
      N1=ID(NT-1)
      N2=ID(NT)
      CALL INM(nt,M2)
    3 M=M1+(M2-M1)/(N2-N1)*(TD1-N1)
      RETURN
      END
C
      SUBROUTINE INM(N,MP)
      REAL MF(17,36,12),MP,LM,LMV
      COMMON /A/FI,LM/AMF/MF
      IF(FI.LE.80.) GO TO 1
      FI=80.
    1 I=1
      J=1
      FIV=80.
      LMV=0.
    2 I=I+1
      FIV=FIV-5.
      IF(FI.GE.FIV) GO TO 3
      GO TO 2
    3 J=J+1
      LMV=LMV+10.
      IF(LM.GT.LMV) GO TO 3
      IF(LM.GT.350.) J1=1
      IF(LM.LE.350.) J1=J
      AL=(FI-(FIV+5.))/(-5.)
      BETA=(LM-(LMV-10.))/10.
      MP=MF(I-1,J-1,N)+AL*(MF(I,J-1,N)-MF(I-1,J-1,N))+
     +BETA*(MF(I-1,J1,N)-MF(I-1,J-1,N))+AL*BETA*(MF(I,J1,N)-
     -MF(I,J-1,N)-MF(I-1,J1,N)+MF(I-1,J-1,N))
    4 RETURN
      END
C
      SUBROUTINE SCAP(FM0,LT,UT0,KPP,KP1,F107,TD0,F0F2C)
C
C-------------- PACET F0F2 B OPHO AKE ---------------------------
      REAL LT,LMLT,KP,KP1,KPP
      REAL NS0H,NS3H,NSKH,NSKF
      REAL NW0H,NW3H,NWKH,NWKF,NTKF
      FM=ABS(FM0)
      UT=UT0
      TD=TD0
        IF(FM0.GE.0.) GO TO 583
      UT=UT+12.
      IF(UT.GE.24.) UT=UT-24.
      TD=TD+183.
      IF(TD.GE.366.) TD=TD-365.
  583 CONTINUE
         KP=KPP
      IF(KP.LT.KP1) KP=KP1
           NS0H=0.
           NS3H=0.
           NW0H=0.
           NW3H=0.
      RAD=3.1416/180.
      TAT=90.-FM
      LMLT=15*LT
      HAD=3.1416/12.
C--------- ETO --- B C A --- KP=0 ------------------------------------
      X=TAT*SIN(LMLT*RAD)
      Y=-TAT*COS(LMLT*RAD)
      SUT=SIN(UT*HAD)
      D=4.5-1.5*SUT
      C=27.5+2.5*SUT
      B=-5.-5.*SUT
      A=SQRT(X**2+(Y-B)**2)
      NS0H=7.6-2.8/(1+(A/C)**D)
C------- ETO --- B C A --- KP=3 --------------------------------------
      AL1=LMLT+22.5*(1.+SUT)
      AL2=LMLT+15.*(1.+SUT)
      X1=TAT*SIN(AL1*RAD)
      X2=TAT*SIN(AL2*RAD)
      Y1=-TAT*COS(AL1*RAD)
      Y2=-TAT*COS(AL2*RAD)
      X10=14.+SUT
      X20=-2.5*(5.+SUT)
      Y10=-1.5*(1.+SUT)
      Y20=-6.5-1.5*SUT
      GMA1=1.9+0.1*SUT
      GMA2=1.4+0.1*SUT
      A1=(X1-X10)**2+(Y1-Y10)**2/GMA1**2
      A2=(X2-X20)**2+(Y2-Y20)**2/GMA2**2
      NS3H=5.-(1.85+0.35*SUT)*EXP(-A1/144.)
      NS3H=NS3H-1.5*EXP(-A2/100.)
C------- MA --- B C A --- KP=0 --------------------------------------
      ALM=LMLT-25.
      X=TAT*SIN(ALM*RAD)
      Y=-TAT*COS(ALM*RAD)
      AN0A=0.167*Y+0.5*ABS(Y-2.)-
     -     0.3333*ABS(Y-5.)+2.67
      AN0B=0.361*Y+0.311*ABS(Y)+
     +     0.05*ABS(Y+10.)+1.5
      AN0=0.5*(AN0A+AN0B+(AN0A-AN0B)*SUT)
      AN2A=0.1*Y+0.208*ABS(Y-2.)-
     -     0.233*ABS(Y-5.)+0.125*ABS(Y+10.)+4.
      AN2B=0.5*Y+0.167*ABS(Y)+8.
      AN2=0.5*(AN2A+AN2B+(AN2A-AN2B)*SUT)
      X0A=7.
      X0B=0.5*ABS(Y+5.)-2.
      X0=0.5*(X0A+X0B+(X0A-X0B)*SUT)
      AN1A=(LMLT-20.)**4/8.1E+5+(TAT-16.)**4/256.
      IF (AN1A.GT.100.) AN1A=100.
      AN1A=4.*EXP(-AN1A)
      AN1=AN1A/2*(1+SUT)
      DL1A=10.
      DL1B=10.-0.4*Y+0.01*Y**2
      DL1=0.5*(DL1A+DL1B+(DL1A-DL1B)*SUT)
      DL2A=7.
      DL2B=6.-0.3*Y+0.01*Y**2
      DL2=0.5*(DL2A+DL2B+(DL2A-DL2B)*SUT)
                  IF((X-X0).EQ.0.) GO TO 21
                  SX=(X-X0)/ABS(X-X0)
                  GO TO 22
   21             SX=1.
   22 DL=0.5*(DL1**2*(1+SX)+
     +   DL2**2*(1-SX))
      NW0H=AN0+(AN2-AN0)*EXP(-(X-X0)**2/DL)+AN1
C------- MA --- B C A --- KP=3 --------------------------------------
      A=38.+12*SIN((UT-2)*HAD)
      AN0=1.+120./(A-Y)
      DLL=15.+(Y-20.)/6.0
      XL=0.766*SUT*Y-7.66*EXP(-(UT-12)**2/16.)
      AN1A=3.5*EXP(-(20.-Y)/30.)
      AN1B=0.5*(25.-Y)*EXP(-(Y-20.)**2/500.)
      AN1=0.5*(AN1A+AN1B+(AN1A-AN1B)*SIN((UT-3)*HAD))
      ANL=AN1*EXP(-((X-XL)/DLL)**2)
      TATM=16.-2.*SIN((UT-3)*HAD)
      XM=TATM*SIN(ALM*RAD)
      YM=-TATM*COS(ALM*RAD)
      DLM=5.
      AL1M=15.*(9.+10*SIN(0.349*UT)*EXP(-UT/4.3))-25.
      AL2M=180.*SIN(0.349*UT)*EXP(-UT/4.3)-25.
      AN0M=1.+120./(A-YM)+AN1*EXP(-((XM-XL)/DLL)**2)-1.5
      ABCD=((TAT-TATM)/DLM)**4
      IF (ABCD.GT.100.) ABCD=100.
      ANM=AN0M/4.*EXP(-ABCD)*(1+0.6366*ATAN((ALM-AL2M)/2))*
     *    (1-0.6366*ATAN((ALM-AL1M)/2))
      TATE=25.-7.*SUT
      XE=TATE*SIN(ALM*RAD)
      YE=-TATE*COS(ALM*RAD)
      DLE=3.
      AL1E=275.
      AL2E=215.
      AN0E=1.+120./(A-YE)+AN1*EXP(-((XE-XL)/DLL)**2)-1.3
      ABCD=((TAT-TATE)/DLE)**4
      IF (ABCD.GT.100.) ABCD=100.
      A0E=AN0E/4.*EXP(-ABCD)*(1+0.6366*ATAN((ALM-AL2E)/2))*
     *    (1-0.6366*ATAN((ALM-AL1E)/2))
      NW3H=AN0+ANL-ANM-A0E
C------- ETO --- B C A ---KPBXO -------------------------------------
      A1=ZFUN(0.5,-0.5,(KP-1.5)/0.7)
      A2=(1-A1)*(1.+(3.-KP)/20.)
      NSKH=A1*NS0H+A2*NS3H
C------- MA --- B C A --- KPBXO ------------------------------------
      NWKH=A1*NW0H+A2*NW3H
C------- ETO --- F10.7 --- KPBXO ------------------------------------
      B=0.6
      NSKF=NSKH*(1+(B-1)*(200-F107)/110.)
C------- MA --- F10.7 --- KPBXO ------------------------------------
      B=0.1
      NWKF=NWKH*(1.+(B-1.)*(200.-ZFUN(145.,55.,(F107-145.)/27.5))/110.)
C------- TD --- F10.7 --- KPBXO --------------------------------------
      AP=1.5
      B=1+0.5*(AP-1)*(1-COS(TD*3.44E-2))
      A1=0.5*(1+COS(TD*1.72E-2))
      A2=1-A1
      NTKF=(A1*NWKF+A2*NSKF)*B
C------- KPTECKA ACTOTA --- M ----------------------------------
      F0F2C=SQRT(NTKF*1.E+5/1.24E+4)
      RETURN
      END
