C					                                  Feb. 2014
C
C       Count global CCIR-based median afc(UT) and ahc*UT) from CCIR maps fcF2 and hcF2(from M3000 map) 
C       for given UT 
      subroutine subsmi2(AYEAR,AMN,ADY,IMEDF,IMEDH)
C
C
      DIMENSION im(12),da(7,71,0:72),av(0:72),iav(0:72)
c-	+,CC(7,0:72)  ! calculate med-map line-by-line for 71 latitudes
	+,IMEDF(71,0:72,0:23),IMEDH(71,0:72,0:23) ! results of median maps 
	+,ARIG(3),RZAR(3)
      dimension R12y(12)
	integer month
      character*2 ayr,amn,ady,aut,adyr,amnr
	character*1 fht
	character*4 AYEAR
	integer*2 iyr,imn,idy,iut
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
c
C+ SMI input of CCIR coefficients
      OPEN (UNIT=16,FILE='BIN16',STATUS='OLD',
     *    ACCESS='DIRECT',FORM='UNFORMATTED',RECL=11432)
c
      UMR=0.01745329
      PHI=3.1415927
      PHI=ATAN(1.0)*4.
	  UMR=PHI/180.

      XFOF2=0.
      XHMF2=0.
	XHI=0.0
c
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c//       write(*,*) 'ENTER YEAR:'
c//	 read(*,*) AYEAR
	AYR=AYEAR(3:4)
c//       write(*,*) 'ENTER MN:'
c//	 read(*,*) AMN
		read(ayear,*) xyear
	iyear=int(xyear)
		read(ayr,*) yr
		read(amn,*) rmn
	imn=int(rmn)
	month=int(rmn)
C
 	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	ndnr=im(imn)
C
		read(ady,*) rdy
	idy=int(rdy)
	ldac=ndoy(iyr,imn,idy)
C 
C Read R12 for current year:
	  open(19,file='R12.dat',status='OLD')
  211    read(19,*, end=99) j,R12y
         if (j.lt.iyr) goto 211
         close(19)
         R12=R12y(month)
         if (R12.gt.150.0D0)then
            R12=150.0D0
         endif
   99 continue
      close(19)
         cov=63.7D0+(0.728D0+8.9D-4*R12)*R12
	if (cov.gt.193.) cov=193.

C UT cycle
	DO 203 iut=0,23
	UT=float(iut)
C
C GLAT cycle
C
	glat=-90.
	do 301 lat=1,71
	glat=glat+2.5
C
	do k=0,72
	av(k)=0.        !
	enddo

C GLONG cycle
	glon=-185.
	  	do lon=0,72
	glon=glon+5.0
	if (glon.lt.0.) then
	ylon=glon+360.
	else
	ylon=glon
	endif
	      call ccirca(month) !read CCIR.bin coefficients

	call prepccir(glat,ylon,month,UT,cov,hm,aep,bb)

C gec_rz.dat> are using gec_rz.dat file:
	        rssn=R12
       gind=rssn		! GEC=R12
C
C     CALCULATION OF XHI,SUNSET,SUNRISE,COV(F10.7),XHIM ..............

C
	iav(lon)=nint(av(lon))
	IMEDF(lat,lon,iut)=iav(lon) ! results of CCIR foF2 map
	    enddo
c	   write(*,109) (iav(k),k=0,72)

  301	continue                 ! end lat cycle of median map

  203 continue   ! end ut cycle
 
  108 format(3A2,24(1X,I4))	! 
  109 format(73(1X,I4))	! 
      
C
       GOTO 1234
    2 CONTINUE
 1234	continue  !

C+ SMI CCIR files
      CLOSE (UNIT=16,STATUS='KEEP')
C+

c//      write(*,*) infile,outfile
c//      pause ' ' 
   34 RETURN
       END
C==============================================================================
C
      REAL FUNCTION F2OUT(XMODIP,XLATI,XLONGI,R,HOUR)
C     D.BILITZA,20.8.78. PACET XHMF2  NMF2 C COOBAHEM
C     KAPT MKKP(CCIR)  FOF2  M3000.
      DIMENSION FF0(988),MQF(9),F2(13,76,2)
      COMMON /BLOKA/F2
      DATA MQF/11,11,8,4,1,0,0,0,0/
      DO 20 I=1,76
      DO 20 J=1,13
      K=J+13*(I-1)
   20 FF0(K)=(F2(J,I,1)*(100.0-R)+F2(J,I,2)*R)/100.0
      F2OUT=GAMMA1(XMODIP,XLATI,XLONGI,HOUR,6,MQF,9,76,13,988,
     &FF0)
      RETURN
      END

C
      SUBROUTINE CCIRCA(IMONTH)
C     Calculation of coefficients
C     FOF2(76,13)  SM3000(49,9) 
C     for level of solar activity, MODIP and month 
C     using CCIR maps
      DIMENSION F2(13,76,2),FM3N(9,49,2),FM3S(9,49,2)
      COMMON /BLOKA/F2/BLOKB/FM3N,FM3S
      MON=IMONTH+6
      IF (MON.GT.12) MON=MON-12
      READ (16,rec=mon) F2,FM3S
      REWIND 16
      READ (16,rec=imonth) F2,FM3N
      REWIND 16
      RETURN
      END
C
      subroutine cciri(xMODIP,mth,UT,R12,alat,along,foF2,M3000)
      real M3000
      implicit real (a-h,o-z)
c/      character*10 filena
      character*2 cm
      dimension FF0(988),xm0N(441),xm0S(441),F2(13,76,2)
	+,FM3N(9,49,2),FM3S(9,49,2)
      integer QM(7),QF(9),mth
      COMMON /BLOKA/F2/BLOKB/FM3N,FM3S
      save
      data QF/11,11,8,4,1,0,0,0,0/,QM/6,7,5,2,1,0,0/
      data montha,monthb,Rga/13,14,-10.0/
c/      if (mth.ne.montha) then
c/         write(cm,'(I2.2)') mth+10
c/         filena='ccir'//cm//'.asc'
c/         open(77,file=filena,status='OLD')
c/         read(77,'(4E16.8)') F2,FM3
c/         close(77)
c/         montha=mth
c/      endif
      if (R12.ne.Rga.or.mth.ne.monthb) then
         RR2=R12/100.0
         RR1=1.0-RR2
         do i=1,76
         do j=1,13
            k=j+13*(i-1)
            FF0(k)=F2(j,i,1)*RR1+F2(j,i,2)*RR2
         enddo
         enddo
         do i=1,49
         do j=1,9
            k=j+9*(i-1)
            xm0N(k)=FM3N(j,i,1)*RR1+FM3N(j,i,2)*RR2
	xm0S(k)=FM3S(j,i,1)*RR1+FM3S(j,i,2)*RR2
         enddo
         enddo
         Rga=R12
         monthb=mth
      endif
      foF2= gamma1(xMODIP,alat,along,UT,6,QF,9,76,13,988,FF0)
	if (alat.ge.0.) then
      M3000=gamma1(xMODIP,alat,along,UT,4,QM,7,49, 9,441,xm0N)
	else
	M3000=gamma1(xMODIP,alat,along,UT,4,QM,7,49, 9,441,xm0S)
	endif
      return
      end
C--------------------------------------------------

C--------------------------------------------------
      real function peakh(foE,foF2,M3000)
      real MF,M3000
      sqM=M3000*M3000
      MF=M3000*sqrt((0.0196D0*sqM+1.D0)/(1.2967D0*sqM-1.0D0))
      If(foE.ge.1.0D-30) then
         ratio=foF2/foE
         ratio=djoin(ratio,1.75D0,20.0D0,ratio-1.75D0)
         dM=0.253D0/(ratio-1.215D0)-0.012D0
      else
         dM=-0.012D0
      endif
      peakh=1490.0D0*MF/(M3000+dM)-176.0D0
      return
      end
C--------------------------------------------------
C
crem      REAL FUNCTION GAMMA1(SMODIP,SLAT,SLONG,UT,XHOUR,IHARM,NQ,K1,M,
      REAL FUNCTION GAMMA1(SMODIP,SLAT,SLONG,XHOUR,IHARM,NQ,K1,M,
     &MM,M3,SFE)
C     [SHEIKH,4.3.77]. CALCULATION OF RATIO (FOF2/M3000) USING CCIR MAPS
C     FOR NUMERICAL COEFFICIENTS SFE(M,2*IHARM+1).
C     NQ(K1) - TERMS OF SERIES NQ1,NQ2,NQ3,...OF EXPANSION ON HIGH ORDER
C     LATITUDES FOR EACH LONGITUDINAL HARMONICS (IHARM),
C     M=1+NQ1+2(NQ2+1)+2(NQ3+1)+... .
      DIMENSION NQ(K1),XSINX(13),COEF(100),C(12),S(12),SFE(M3)
      parameter (RD=57.2957795)
  100 TIME=(15.0*XHOUR-180.0)/RD
  150 S(1)=SIN(TIME)
      C(1)=COS(TIME)
      DO 250 I=2,IHARM
      C(I)=C(1)*C(I-1)-S(1)*S(I-1)
      S(I)=C(1)*S(I-1)+S(1)*C(I-1)
250   CONTINUE
      DO 300 I=1,M
      COEF(I)=SFE((I-1)*MM+1)
      DO 300 J=1,IHARM
      COEF(I)=COEF(I)+SFE((I-1)*MM+2*J)*S(J)+SFE((I-1)*MM+2*J+1)*C(J)
300   CONTINUE
      SUM=COEF(1)
      SS=SIN(SMODIP/RD)
      S3=SS
      XSINX(1)=1.0
      INDEX=NQ(1)
      DO 350 J=1,INDEX
      SUM=SUM+COEF(1+J)*SS
      XSINX(J+1)=SS
      SS=SS*S3
350   CONTINUE
      XSINX(NQ(1)+2)=SS*S3
      NP=NQ(1)+1
      SS=COS(SLAT/RD)
      S3=SS
      DO 400 J=2,K1
      S0=SLONG*FLOAT(J-1)/RD
      S1=COS(S0)
      S2=SIN(S0)
      INDEX=NQ(J)+1
      DO 450 L=1,INDEX
      NP=NP+1
      SUM=SUM+COEF(NP)*XSINX(L)*SS*S1
      NP=NP+1
      SUM=SUM+COEF(NP)*XSINX(L)*SS*S2
450   CONTINUE
      SS=SS*S3
400   CONTINUE
      GAMMA1=SUM
      RETURN
      END
C
C--------------------------------------------------
C
      FUNCTION DELH(ALST,TD,AFI)
      TD1=TD-14.
      IF(TD1.LE.0.) TD1=TD1+365.
      YD=(TD1+29.5)/30.5
      Y=YD
      IF(Y.GT.6.5)Y=13-Y
      A1=0.02+ZFUN(1.,-1.,(Y-2.9)/1.1)/8.+0.18*EFUN(Y,2.,0.6,2)
      A2=ZFUN(0.07,0.18,(YD-1.)/1.2)-ZFUN(1.,1.,(YD-13.)/0.6)*0.18
      A2=A2-0.08*EFUN(YD,9.,4.-YD/6.,2)
      A3=ZFUN(0.09,0.28,YD-1)-0.28*ZFUN(1.,1.,YD-13)
      A3=A3-0.26*EFUN(YD,7.7,2.7,2)-0.05*EFUN(YD,3.,0.5,2)
      A4=ZFUN(.14,-.12,(YD-3.7)/0.6)+ZFUN(1.,1.,(YD-10.1)/.4)*0.12
      A4=A4-ZFUN(1.,-1.,(Y-1.3)*5)*0.11+EFUN(YD,6.8,1.,2)/10.
      DELH=0.98+A1*EFUN(ALST,0.,1.8,2)+A2*EFUN(ALST,5.2,1.4,2)
      DELH=DELH-(0.6*A3+0.4*A1-A4)*EFUN(ALST,21.,1.3,2)
      DELH=DELH+(5.*A3+(A1-A3)*(ALST-19.))*
     1     ZFUN(1.,1.,(ALST-17.7)/0.6)/10.
      DELH=DELH+(1-DELH)*AFI**2*(90.-2.*AFI)/27000.
      RETURN
      END
c
      real function zfun(a,b,c)
      cc=c*c
      c4=cc*cc
      cc=c4*c4
      cc=(cc+256.)**0.125
      zfun=a+b*c/cc
      return
      end
c
      real function efun(a,b,c,n)
      d=(a-b)/c
      d2=d*d
      if (n.gt.2) d2=d2*d2
      efun=exp(-(80.*d2)/(80.+d2))
      return
      end
C************************************************************
C
C************************************************************
      subroutine prepccir(alat,along,mth,UT,flx,hm,aep,bb)
      character*15 filenam
      real M3000
      dimension pmodip(0:39,-1:37)
      dimension hm(3),aep(3),bb(6)

      save

      parameter (pi12=0.261799387788149D0)
      parameter (DR=1.74532925199433D-2,RD=5.729577951308232D1)
      data UT0,mth0,flx0,jdip/-100.0,-1,-1.0,0/
      mth1=mth
      flx1=flx
      ut1=mod(UT+24.0,24.0)

      if (flx1.lt.63.0) then
	flx1=63.0
      endif
      
      if (jdip.eq.0) then
         filenam='modip.asc'
         call modin(filenam,pmodip)
         jdip=1
      endif
      if (ut1.ne.UT0.or.mth1.ne.mth0) then
         call sdec(mth1,ut1,sdelta,cdelta)
         UT0=ut1
         mth0=mth1
      endif
      if (flx1.ne.flx0) then
         R12=sqrt(167273.0+(flx1-63.7)*1123.6)-408.99
         flx0=flx1
      endif

      xlt=mod(ut1+along/15.0+24.0,24.0)
      xMODIP=amodip(pmodip,alat,along)
      cchi=sin(alat*DR)*sdelta-cos(alat*DR)*cdelta*
     * cos(pi12*xlt)
      chi=atan2(sqrt(1.0-cchi*cchi),cchi)*RD
      call cciri(xMODIP,mth0,UT0,R12,alat,along,foF2,M3000)
      call ef1r(alat,mth1,flx1,chi,foF2, efoE,efoF1)
      call prepmdgr(mth0,R12,foF2,efoF1,efoE,M3000,hm,bb,aep)
      return
      end
C-----------------------------------------------------------------
      subroutine modin(filenam,pmodip)
      character*15 filenam
      dimension pmodip(0:39,-1:37)   
      character*100 txt
      parameter(latp=36,lngp=36,lathp=18,lnghp=18)

      open(31,status='OLD',file=filenam,form='FORMATTED')
      read(31,'(A)')txt
      do i=-lathp,lathp
         read(31,*) (pmodip(i+lathp+1,j+lnghp),j=-lnghp,lnghp)
      enddo
      close(31)
      do i=0,lngp
         pmodip(0,i)=pmodip(2,mod((i+lnghp),lngp))
         pmodip(latp+2,i)=pmodip(latp,mod((i+lnghp),lngp))
         pmodip(latp+3,i)=pmodip(latp-1,mod((i+lnghp),lngp))
      enddo
      do i=0,latp+3
         pmodip(i,-1)=pmodip(i,lngp-1)
         pmodip(i,lngp+1)=pmodip(i,1)
      enddo
      return
      end
C-----------------------------------------------------------------
      subroutine sdec(mth,UT,sdelta,cdelta)
      parameter (DR=1.74532925199433D-2)

      doy=mth*30.5D0-15.0D0
      t =doy + (18.0D0-UT)/24.0D0
      amrad=(0.9856D0*t - 3.289D0)*DR
      aLrad = amrad + (1.916D0*sin(amrad)+0.020D0*sin(2.0D0*amrad)+
     + 282.634D0)*DR
      sdelta=0.39782D0*sin(aLrad)
      cdelta=sqrt(1.0D0-sdelta*sdelta)
      return
      end
C-----------------------------------------------------------------
      real function amodip(pmodip,alat,along)

      dimension pmodip(0:39,-1:37)
      dimension z(4),z1(4)
      parameter(lngp=36,dlatp=5.0D0,dlngp=10.0D0)

      along1=amod(along+360.0,360.0)
      dlng1=(along1+180.0D0)/dlngp
      dlng1=dlng1-aint(dlng1)
      j1=int((along1+180.0D0)/dlngp)-2
      if (j1.lt.0) j1=j1+lngp
      if (j1.gt.lngp-3) j1=j1-lngp
      a=(alat+90.0D0)/dlatp+1.0D0
      i=int(a)-2
      a=a-float(i+2)
      do k = 1,4
         do j=1,4
         z1(j)=pmodip(i+j,j1+k)
         enddo
         z(k)=finter3(z1,a)
      enddo
      amodip=finter3(z,dlng1)
      return
      end
C-----------------------------------------------------------------
        real function finter3(z,x)
      dimension z(4),a(0:3)

      dx=x+x-1.0D0
      if (abs(dx+1.0D0).lt.1.0D-10) then
         finter3=z(2)
      else
         g1=(z(3)+z(2))
         g2=(z(3)-z(2))
         g3=(z(4)+z(1))
         g4=(z(4)-z(1))/3.0D0
         a(0)=(9.0D0*g1-g3)
         a(1)=(9.0D0*g2-g4)
         a(2)=(g3-g1)
         a(3)=(g4-g2)
         zi=0.0D0
         do j=3,0,-1
            zi=zi*dx+a(j)
         enddo
         finter3=zi/16.0D0
      endif
      return
      end
C-----------------------------------------------------------------
      subroutine ef1r(alat,mth,flx,chi,foF2,efoE,efoF1)
      parameter (DR=1.745329252E-2)
      parameter (chi0=86.232928)
	efof1=fof2
      chin=djoin(90.0-0.24*fexp(20.0-0.20*chi),chi,12.0,
     & chi-chi0)
      ee=fexp(0.3*alat)
      seas=1.0-2.0/(ee+1.0)
      if(mth.eq.1.or.mth.eq.2.or.mth.eq.11.or.mth.eq.12) 
     +  sfac=(1.112+0.019*seas)*flx**0.25
      if(mth.eq.3.or.mth.eq.4.or.mth.eq.9.or.mth.eq.10)
     +  sfac=1.112*flx**0.25
      if(mth.eq.5.or.mth.eq.6.or.mth.eq.7.or.mth.eq.8)
     +  sfac=(1.112-0.019*seas)*flx**0.25
      fa=sfac*fexp(log(cos(chin*DR))*0.3)
      efoE=sqrt(fa*fa+0.49)
      return
      end
C-----------------------------------------------------------------
	      real function djoin(f1,f2,alpha,x)
      real f1,f2,alpha,x,ee,fexp
      ee=fexp(alpha*x)
      djoin=(f1*ee+f2)/(ee+1.0)
      return
      end
C-----------------------------------------------------------------
       real function fexp(a)
      real a
      if(a.gt.80.0) then
         fexp=5.5406E34
         return
      endif
      if(a.lt.-80.0D0) then
         fexp=1.8049E-35
         return
      endif
      fexp=exp(a)
      return
      end
C-----------------------------------------------------------------

