C					                                  Feb. 2014
C
C       Count global CCIR-based median afc(UT) and ahc*UT) from CCIR maps fcF2 and hcF2(from M3000 map) 
C       for given UT 
c-      subroutine subsmi2(AYEAR,AMN,ADY,IMEDF,IMEDH)
      subroutine subsmi2(AYEAR,AMN,ADY)
C
C
      DIMENSION im(12),av(0:72)
c-	+,CC(7,0:72)  ! calculate med-map line-by-line for 71 latitudes
	+,IMEDF(71,0:72,0:23),IMEDH(71,0:72,0:23) ! results of median maps 
	+,resmodip(71,0:72) ! modip data for IONEX map
      dimension R12y(0:12),F2(13,76,2),FM3(9,49,2)
	+,F2n(13,76,2),FM3n(9,49,2) !current and prev/next month
	integer month
      character*2 ayr,amn,ady
	character*4 AYEAR
	integer*2 iyr,imn,idy,iut
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
c-      COMMON /BLOKA/F2,F2n/BLOKB/FM3,FM3n
      common/BLOKM/resmodip
      COMMON /BMED/IMEDF,IMEDH,IMEDT
C+ SMI input of CCIR coefficients
      OPEN (UNIT=16,FILE='BIN16',STATUS='OLD',
     *    ACCESS='DIRECT',FORM='UNFORMATTED',RECL=11432)
c
      UMR=0.01745329
      PHI=3.1415927
      PHI=ATAN(1.0)*4.
	  UMR=PHI/180.

      XFOF2=0.
      XHMF2=0.
	XHI=0.0
c
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c//       write(*,*) 'ENTER YEAR:'
c//	 read(*,*) AYEAR
	AYR=AYEAR(3:4)
c//       write(*,*) 'ENTER MN:'
c//	 read(*,*) AMN
		read(ayear,*) xyear
	iyear=int(xyear)
		read(ayr,*) yr
		read(amn,*) rmn
	imn=int(rmn)
	month=int(rmn)
C
 	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	ndnr=im(imn)
C
		read(ady,*) rdy
	idy=int(rdy)
	ldac=ndoy(iyr,imn,idy)
C 
	mnmidy=im(imn)/2
	if (idy.lt.mnmidy+1) then
	monthn=month-1
	if (monthn.eq.0) monthn=12
	else
	monthn=month+1
	if (monthn.gt.12) monthn=1
	endif
C Read R12 for current year:
	  open(19,file='R12.dat',status='OLD')
  211    read(19,*, end=99) j,(R12y(k),k=1,12)
         if (j.lt.iyear) then
	R12y(0)=R12y(12)
	   goto 211
	endif
         close(19)
         R12=R12y(month)
	if ((monthn.eq.12).and.(month.eq.1)) then
	 R12n=R12y(0)
	else
	 R12n=R12y(monthn)
	endif
         if (R12.gt.150.0) R12=150.0
	         if (R12n.gt.150.0) R12n=150.0
   99 continue
      close(19)
         cov=63.7+(0.728+8.9E-4*R12)*R12
	if (cov.gt.193.) cov=193.
	      if (cov.lt.63.0) then
	 cov=63.0
      endif

         covn=63.7+(0.728+8.9E-4*R12n)*R12n
	if (covn.gt.193.) covn=193.
	      if (covn.lt.63.0) then
	 covn=63.0
      endif
crem	call ccirca(month) !Read CCIR coefficients
C
	call subccir(month,monthn,F2,F2n,FM3,FM3n) !Read CCIR coefficients
C
	         call submodip  ! re-arrange modip to IONEX grids
C UT cycle
	DO 203 iut=0,23
	UT=float(iut)
C
C GLAT cycle
C
	glat=-90.
	do 301 lat=1,71
	glat=glat+2.5
C
	do k=0,72
	av(k)=0.        !
	enddo

C GLONG cycle
	glon=-185.
	  	do lon=0,72
	glon=glon+5.0
	if (glon.lt.0.) then
	ylon=glon+360.
	else
	ylon=glon
	endif
	idmn=im(month)
	smodip=resmodip(lat,lon)
	call prepccir(glat,ylon,smodip,month,monthn,idy,idmn,UT,R12,R12n
	+,cov,covn,F2,F2n,FM3,FM3n,hm,fm,foe)

C
	IMEDF(lat,lon,iut)=nint(fm*10.) ! results of CCIR foF2 map
	IMEDH(lat,lon,iut)=nint(hm) ! results of CCIR hmF2 map
	    enddo          !  
C
c	   write(*,109) (iav(k),k=0,72)

  301	continue                 ! end lat cycle of median map

  203 continue   ! end ut cycle
 
  108 format(3A2,24(1X,I4))	! 
  109 format(73(1X,I4))	! 
      
C
       GOTO 1234
    2 CONTINUE
 1234	continue  !

C+ SMI CCIR files
      CLOSE (UNIT=16,STATUS='KEEP')
C+

c//      write(*,*) infile,outfile
c//      pause ' ' 
   34 RETURN
       END
C==============================================================================
C
      SUBROUTINE SUBCCIR(IMONTH,IMONTHN,F2,F2n,FM3,FM3n)
C     Calculation of coefficients
C     FOF2(76,13)  SM3000(49,9) 
C     for level of solar activity, MODIP and current month + prec/next month
C     using CCIR maps
      DIMENSION F2(13,76,2),FM3(9,49,2),F2n(13,76,2),FM3n(9,49,2)
c-      COMMON /BLOKA/F2,F2n/BLOKB/FM3,FM3n
      READ (16,rec=imonth) F2,FM3
      REWIND 16
      READ (16,rec=imonthn) F2n,FM3n
      REWIND 16
      RETURN
      END
C
      subroutine cciri(xMODIP,mth,UT,R12,alat,along,foF2,M3000,F2x,FM3x)
      implicit real (a-h,o-z)
      real M3000
c/      character*2 cm
      dimension FF0(988),xm0(441)
	+,F2x(13,76,2)
	+,FM3x(9,49,2)
      integer QM(7),QF(9)
CXX	COMMON /BLOKA/F2,F2n/BLOKB/FM3,FM3n
      save
      data QF/11,11,8,4,1,0,0,0,0/,QM/6,7,5,2,1,0,0/
      data montha,monthb,Rga/13,14,-10.0D0/
      if (mth.ne.montha) then
c/         write(cm,'(I2.2)') mth+10
c/         filena='ccir'//cm//'.asc'
c/         open(77,file=filena,status='OLD')
c/         read(77,'(4E16.8)') F2,FM3
c/         close(77)
         montha=mth
      endif
      if (R12.ne.Rga.or.mth.ne.monthb) then
         RR2=R12/100.0
         RR1=1.0-RR2
         do i=1,76
         do j=1,13
            k=j+13*(i-1)
            FF0(k)=F2x(j,i,1)*RR1+F2x(j,i,2)*RR2
         enddo
         enddo
         do i=1,49
            do j=1,9
            k=j+9*(i-1)
            xm0(k)=FM3x(j,i,1)*RR1+FM3x(j,i,2)*RR2
		  enddo
         enddo
         Rga=R12
         monthb=mth
      endif
      foF2= gamma1(xMODIP,alat,along,UT,6,QF,9,76,13,988,FF0)
	M3000=gamma1(xMODIP,alat,along,UT,4,QM,7,49, 9,441,xm0)
      return
      end
C--------------------------------------------------

C--------------------------------------------------
      real function peakh(foE,foF2,M3000)
      real MF,M3000
      sqM=M3000*M3000
      MF=M3000*sqrt((0.0196*sqM+1.)/(1.2967*sqM-1.0))
      If(foE.ge.1.0E-30) then
         ratio=foF2/foE
         ratio=djoin(ratio,1.75,20.0,ratio-1.75)
         dM=0.253/(ratio-1.215)-0.012
      else
         dM=-0.012
      endif
      peakh=1490.0*MF/(M3000+dM)-176.0
      return
      end
C--------------------------------------------------

      REAL FUNCTION GAMMA1(SMODIP,SLAT,SLONG,HOUR,IHARM,NQ,
     &                          K1,M,MM,M3,SFE)
C CALCULATES GAMMA1=FOF2 OR M3000 USING CCIR NUMERICAL MAP
C COEFFICIENTS SFE(M3) FOR MODIFIED DIP LATITUDE (SMODIP/DEG)
C GEOGRAPHIC LATITUDE (SLAT/DEG) AND LONGITUDE (SLONG/DEG)
C AND UNIVERSIAL TIME (HOUR/DECIMAL HOURS).
C NQ(K1) IS AN INTEGER ARRAY GIVING THE HIGHEST DEGREES IN
C LATITUDE FOR EACH LONGITUDE HARMONIC.
C M=1+NQ1+2(NQ2+1)+2(NQ3+1)+... .
C SHEIKH,4.3.77.
      REAL*8 C(12),S(12),COEF(100),SUM
      DIMENSION NQ(K1),XSINX(13),SFE(M3)
      COMMON/CONST/UMR
      HOU=(15.0*HOUR-180.0)*UMR
      S(1)=SIN(HOU)
      C(1)=COS(HOU)
      DO 250 I=2,IHARM
      C(I)=C(1)*C(I-1)-S(1)*S(I-1)
      S(I)=C(1)*S(I-1)+S(1)*C(I-1)
250   CONTINUE
      DO 300 I=1,M
      MI=(I-1)*MM
      COEF(I)=SFE(MI+1)
      DO 300 J=1,IHARM
      COEF(I)=COEF(I)+SFE(MI+2*J)*S(J)+SFE(MI+2*J+1)*C(J)
300   CONTINUE
      SUM=COEF(1)
      SS=SIN(SMODIP*UMR)
      S3=SS
      XSINX(1)=1.0
      INDEX=NQ(1)
      DO 350 J=1,INDEX
      SUM=SUM+COEF(1+J)*SS
      XSINX(J+1)=SS
      SS=SS*S3
350   CONTINUE
      XSINX(NQ(1)+2)=SS
      NP=NQ(1)+1
      SS=COS(SLAT*UMR)
      S3=SS
      DO 400 J=2,K1
      S0=SLONG*(J-1.)*UMR
      S1=COS(S0)
      S2=SIN(S0)
      INDEX=NQ(J)+1
      DO 450 L=1,INDEX
      NP=NP+1
      SUM=SUM+COEF(NP)*XSINX(L)*SS*S1
      NP=NP+1
      SUM=SUM+COEF(NP)*XSINX(L)*SS*S2
450   CONTINUE
      SS=SS*S3
400   CONTINUE
      GAMMA1=SUM
      RETURN
      END
C
C
C
C************************************************************
      subroutine prepccir(alat,along,xmodip,mth,mth1,idy,idmn,UT,R12
	+,R12n,flx,flxn,F2,F2n,FM3,FM3n,hmf2,fof2,foe)
      real M3000,M3000a,M3000b
	integer*2 idy
      dimension 
c-	pmodip(0:39,-1:37)
	+ F2(13,76,2)
	+,FM3(9,49,2)
	+,F2n(13,76,2)
	+,FM3n(9,49,2)
crem	      COMMON /BLOKA/F2,F2n/BLOKB/FM3,FM3n

      save
      parameter (pi12=0.26179939)
      parameter (DR=1.745329252E-2,RD=57.29577951)
CREM      data UT0,mth0,flx0,jdip/-100.0,-1,-1.0,0/
      data UT0,mth0/-100.0,-1/
crem      mth1=mth
crem      flx1=flx
      ut1=mod(UT+24.0,24.0)

      
crem      if (jdip.eq.0) then
CREM         filenam='modip.asc'
CREM         filenam='modip.txt'
crem         call modin(filenam,pmodip)
crem         jdip=1
crem      endif
      if (ut1.ne.UT0.or.mth1.ne.mth0) then
         call sdec(mth1,ut1,sdelta,cdelta)
         UT0=ut1
         mth0=mth1
      endif
crem      if (flx1.ne.flx0) then
crem         R12=sqrt(167273.0+(flx1-63.7)*1123.6)-408.99
crem         flx0=flx1
crem      endif
	if (idy.lt.idmn/2+1) then
C 30.3 days between mid-prec month and mid-current month 
	idyr=15.15+idy
	else
C 30.3 days between mid-current month and mid-next month
	idyr=idy-15.15
	endif
      xlt=mod(ut1+along/15.0+24.0,24.0)
crem      xMODIP=amodip(pmodip,alat,along)
      cchi=sin(alat*DR)*sdelta-cos(alat*DR)*cdelta*
     * cos(pi12*xlt)
      chi=atan2(sqrt(1.0-cchi*cchi),cchi)*RD
      call cciri(xMODIP,mth,UT0,R12,alat,along,foF2a,M3000a,F2,FM3)
      call cciri(xMODIP,mth1,UT0,R12n,alat,along,foF2b,M3000b,F2n,FM3n)
	fof2=foF2a+(foF2b-foF2a)*idyr/30.3
	call ef1r(alat,mth,flx,chi,foEa)
	call ef1r(alat,mth1,flxn,chi,foEb)
	foe=foea+(foeb-foea)*idyr/30.3
c      call prepmdgr(mth0,R12,foF2,efoF1,efoE,M3000,hm,bb,aep)
      M3000=M3000a+(M3000b-M3000a)*idyr/30.3
      hmF2=peakh(efoE,foF2,M3000)
      return
      end
C-----------------------------------------------------------------
      subroutine submodip
C TLG.............................................Feb. 2014
C Insert data from file 'modip.asc' to DATA pmodip
      dimension pmodip(0:36,37),resmodip(71,0:72)
	+,am1(0:36),am2(0:36),am(0:36) ! re-arranged 2 lines for glong=-180:10:180
      parameter(latp=36,lngp=36,lathp=18,lnghp=18)
	common/BLOKM/resmodip

C Epoch,2010.0,-,based,on,Spherical,harmonic,coefficients,of,the,10th,Generation,IGRF,(revised,2011)
	data pmodip/
C glat=-90,glon=0:10:360
	* -90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.
	+,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.
     +,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.,-90.
C glat=-85,glon=0:10:360
     *,-76.44,-76.48,-76.53,-76.60,-76.68,-76.77,-76.86,-76.97,-77.07
	+,-77.17,-77.26,-77.35,-77.42,-77.48,-77.52,-77.55,-77.55,-77.54
     +,-77.50,-77.45,-77.39,-77.31,-77.22,-77.13,-77.03,-76.93,-76.84
     +,-76.75,-76.66,-76.59,-76.52,-76.47,-76.43,-76.41,-76.40,-76.41
     +,-76.44
C glat=-80,glon=0:10:360
     *,-70.43,-70.52,-70.65,-70.82,-71.02,-71.26,-71.52,-71.79,-72.07
	+,-72.35,-72.62,-72.86,-73.06,-73.23,-73.34,-73.39,-73.38,-73.31
     +,-73.19,-73.04,-72.85,-72.63,-72.40,-72.15,-71.89,-71.63,-71.38
     +,-71.15,-70.93,-70.75,-70.60,-70.48,-70.40,-70.36,-70.35,-70.37
     +,-70.43
C glat=-75,glon=0:10:360
     *,-65.69,-65.83,-66.03,-66.30,-66.63,-67.03,-67.48,-67.95,-68.45
	+,-68.94,-69.40,-69.84,-70.21,-70.50,-70.68,-70.73,-70.64,-70.46
     +,-70.20,-69.89,-69.55,-69.18,-68.78,-68.36,-67.93,-67.49,-67.06
     +,-66.66,-66.30,-66.01,-65.80,-65.65,-65.57,-65.54,-65.55,-65.60
     +,-65.69
C glat=-70,glon=0:10:360
     *,-61.76,-61.93,-62.17,-62.52,-62.98,-63.53,-64.17,-64.86,-65.56
	+,-66.26,-66.94,-67.57,-68.13,-68.59,-68.84,-68.77,-68.46,-68.05
     +,-67.62,-67.16,-66.68,-66.18,-65.65,-65.09,-64.49,-63.86,-63.23
     +,-62.65,-62.15,-61.77,-61.53,-61.42,-61.41,-61.47,-61.55,-61.65
     +,-61.76
C glat=-65,glon=0:10:360
     *,-58.57,-58.73,-58.96,-59.35,-59.89,-60.59,-61.41,-62.28,-63.18
	+,-64.06,-64.91,-65.70,-66.42,-67.09,-67.34,-66.76,-66.19,-65.63
     +,-65.08,-64.52,-63.96,-63.38,-62.76,-62.08,-61.33,-60.52,-59.69
     +,-58.90,-58.24,-57.79,-57.59,-57.63,-57.81,-58.05,-58.27,-58.44
     +,-58.57
C glat=-60,glon=0:10:360
     *,-56.13,-56.23,-56.40,-56.74,-57.32,-58.13,-59.08,-60.11,-61.15
	+,-62.16,-63.09,-63.93,-64.63,-65.02,-64.83,-64.32,-63.73,-63.12
     +,-62.51,-61.91,-61.29,-60.66,-59.98,-59.22,-58.36,-57.39,-56.34
     +,-55.33,-54.50,-54.00,-53.93,-54.22,-54.73,-55.27,-55.70,-55.98
     +,-56.13
C glat=-55,glon=0:10:360
     *,-54.42,-54.43,-54.46,-54.69,-55.23,-56.07,-57.12,-58.25,-59.37
	+,-60.42,-61.34,-62.08,-62.52,-62.59,-62.30,-61.82,-61.23,-60.60
     +,-59.95,-59.30,-58.64,-57.97,-57.24,-56.43,-55.48,-54.37,-53.13
     +,-51.89,-50.88,-50.37,-50.50,-51.18,-52.13,-53.07,-53.80,-54.24
     +,-54.42
C glat=-50,glon=0:10:360
     *,-53.33,-53.27,-53.11,-53.13,-53.54,-54.34,-55.42,-56.60,-57.74
	+,-58.75,-59.55,-60.07,-60.27,-60.16,-59.83,-59.33,-58.74,-58.09
     +,-57.40,-56.70,-55.98,-55.25,-54.47,-53.61,-52.60,-51.38,-49.97
     +,-48.51,-47.33,-46.83,-47.24,-48.41,-49.91,-51.32,-52.40,-53.07
     +,-53.33
C glat=-45,glon=0:10:360
     *,-52.62,-52.56,-52.23,-51.98,-52.17,-52.86,-53.90,-55.05,-56.14
	+,-57.04,-57.66,-57.95,-57.94,-57.73,-57.35,-56.85,-56.24,-55.55
     +,-54.81,-54.05,-53.26,-52.45,-51.59,-50.66,-49.59,-48.29,-46.73
     +,-45.06,-43.71,-43.24,-44.00,-45.75,-47.86,-49.77,-51.24,-52.20
     +,-52.62
C glat=-40,glon=0:10:360
     *,-52.04,-52.07,-51.62,-51.11,-51.00,-51.49,-52.42,-53.49,-54.48
     +,-55.22,-55.62,-55.68,-55.52,-55.22,-54.82,-54.30,-53.66,-52.92
     +,-52.11,-51.27,-50.39,-49.46,-48.49,-47.46,-46.30,-44.91,-43.21
     +,-41.33,-39.79,-39.38,-40.57,-43.00,-45.77,-48.20,-50.08,-51.37
     +,-52.04
C glat=-35,glon=0:10:360
     *,-51.34,-51.53,-51.05,-50.30,-49.86,-50.07,-50.82,-51.77,-52.62
     +,-53.19,-53.38,-53.24,-52.94,-52.58,-52.15,-51.60,-50.91,-50.08
     +,-49.18,-48.24,-47.24,-46.17,-45.03,-43.84,-42.55,-41.04,-39.17
     +,-37.03,-35.27,-34.95,-36.70,-39.94,-43.44,-46.44,-48.74,-50.39
     +,-51.34
C glat=-30,glon=0:10:360
     *,-50.33,-50.68,-50.21,-49.27,-48.51,-48.40,-48.92,-49.71,-50.42
     +,-50.84,-50.85,-50.52,-50.09,-49.68,-49.22,-48.63,-47.86,-46.92
     +,-45.87,-44.79,-43.64,-42.38,-41.03,-39.62,-38.14,-36.44,-34.32
     +,-31.83,-29.81,-29.64,-32.11,-36.34,-40.74,-44.37,-47.13,-49.11
     +,-50.33
C glat=-25,glon=0:10:360
     *,-48.83,-49.28,-48.81,-47.71,-46.64,-46.21,-46.50,-47.13,-47.73
     +,-48.05,-47.90,-47.40,-46.85,-46.40,-45.91,-45.25,-44.36,-43.23
     +,-41.99,-40.70,-39.36,-37.88,-36.26,-34.57,-32.83,-30.85,-28.36
     +,-25.42,-23.10,-23.17,-26.55,-32.00,-37.49,-41.91,-45.15,-47.43
     +,-48.83
C glat=-20,glon=0:10:360
     *,-46.67,-47.13,-46.59,-45.32,-43.95,-43.22,-43.30,-43.82,-44.36
     +,-44.61,-44.34,-43.67,-43.02,-42.55,-42.03,-41.27,-40.20,-38.82
     +,-37.28,-35.73,-34.14,-32.40,-30.47,-28.45,-26.38,-24.03,-21.05
     +,-17.60,-15.03,-15.45,-19.84,-26.69,-33.52,-38.89,-42.66,-45.19
     +,-46.67
C glat=-15,glon=0:10:360
     *,-43.62,-43.99,-43.32,-41.80,-40.11,-39.10,-39.03,-39.48,-40.03
     +,-40.28,-39.91,-39.09,-38.35,-37.89,-37.35,-36.46,-35.15,-33.41
     +,-31.47,-29.55,-27.67,-25.64,-23.39,-21.02,-18.60,-15.84,-12.36
     +, -8.50, -5.86, -6.70,-11.99,-20.23,-28.57,-35.07,-39.44,-42.15
     +,-43.62
C glat=-10,glon=0:10:360
     +,-39.36,-39.57,-38.69,-36.86,-34.78,-33.49,-33.29,-33.76,-34.37
     +,-34.68,-34.26,-33.31,-32.53,-32.12,-31.58,-30.55,-28.93,-26.74
     +,-24.28,-21.93,-19.72,-17.44,-14.91,-12.26, -9.57, -6.49, -2.68
     +,  1.29,  3.72,  2.50, -3.32,-12.59,-22.38,-30.12,-35.13,-37.99
     +,-39.36
C glat= -5,glon=0:10:360
     *,-33.48,-33.47,-32.33,-30.10,-27.57,-25.98,-25.71,-26.23,-26.96
     +,-27.37,-26.96,-25.95,-25.20,-24.92,-24.45,-23.30,-21.36,-18.67
     +,-15.64,-12.83,-10.36, -7.91, -5.26, -2.51,   .26,  3.43,  7.20
     +, 10.87, 12.83, 11.38,  5.58, -4.01,-14.81,-23.66,-29.31,-32.29
     +,-33.48
C glat=  0,glon=0:10:360
     *,-25.55,-25.26,-23.83,-21.19,-18.22,-16.35,-16.03,-16.62,-17.47
     +,-18.02,-17.70,-16.73,-16.12,-16.09,-15.78,-14.61,-12.45, -9.34
     +, -5.85, -2.71,  -.13,  2.28,  4.84,  7.46, 10.07, 13.02, 16.40
     +, 19.45, 20.86, 19.33, 14.01,  4.96, -5.96,-15.42,-21.55,-24.58
     +,-25.55
C glat=  5,glon=0:10:360
     *,-15.33,-14.75,-13.08,-10.17, -6.95, -4.96, -4.62, -5.22, -6.12
     +, -6.76, -6.59, -5.82, -5.49, -5.78, -5.76, -4.75, -2.59,   .64
     +,  4.29,  7.48,  9.97, 12.15, 14.43, 16.73, 19.03, 21.58, 24.35
     +, 26.69, 27.58, 26.09, 21.51, 13.64,  3.67, -5.53,-11.70,-14.65
     +,-15.33
C glat= 10,glon=0:10:360
     *, -3.28, -2.46,  -.72,  2.10,  5.17,  7.04,  7.37,  6.83,  6.04
     +,  5.41,  5.42,  5.87,  5.86,  5.24,  4.90,  5.55,  7.41, 10.39
     +, 13.81, 16.77, 18.99, 20.86, 22.77, 24.72, 26.67, 28.77, 30.94
     +, 32.63, 33.11, 31.71, 27.91, 21.50, 13.23,  5.27,  -.31, -2.92
     +, -3.28
C glat= 15,glon=0:10:360
     *,  9.21, 10.11, 11.69, 14.09, 16.62, 18.17, 18.46, 18.06, 17.46
     +, 16.96, 16.86, 17.00, 16.70, 15.83, 15.16, 15.37, 16.72, 19.15
     +, 22.04, 24.59, 26.50, 28.06, 29.64, 31.28, 32.94, 34.65, 36.31
     +, 37.50, 37.68, 36.39, 33.30, 28.30, 21.97, 15.79, 11.33,  9.29
     +,  9.21
C glat= 20,glon=0:10:360
     +, 20.51, 21.36, 22.66, 24.47, 26.35, 27.51, 27.75, 27.50, 27.11
     +, 26.77, 26.65, 26.57, 26.08, 25.10, 24.22, 24.03, 24.83, 26.59
     +, 28.86, 30.93, 32.53, 33.85, 35.19, 36.60, 38.03, 39.46, 40.74
     +, 41.56, 41.54, 40.36, 37.86, 34.08, 29.48, 25.06, 21.85, 20.43
     +, 20.51
C glat= 25,glon=0:10:360
     *, 29.81, 30.53, 31.52, 32.81, 34.13, 34.95, 35.16, 35.02, 34.81
     +, 34.62, 34.51, 34.32, 33.74, 32.75, 31.77, 31.30, 31.63, 32.79
     +, 34.44, 36.07, 37.40, 38.54, 39.71, 40.95, 42.22, 43.44, 44.47
     +, 45.05, 44.89, 43.83, 41.81, 38.98, 35.74, 32.72, 30.56, 29.64
     +, 29.81
C glat= 30,glon=0:10:360
     *, 37.11, 37.69, 38.43, 39.33, 40.23, 40.81, 41.01, 40.97, 40.88
     +, 40.81, 40.72, 40.49, 39.89, 38.94, 37.95, 37.32, 37.31, 37.97
     +, 39.11, 40.34, 41.44, 42.46, 43.52, 44.64, 45.79, 46.85, 47.70
     +, 48.12, 47.90, 46.95, 45.31, 43.20, 40.93, 38.91, 37.50, 36.94
     +, 37.11
C glat= 35,glon=0:10:360
     *, 42.85, 43.29, 43.84, 44.47, 45.08, 45.51, 45.71, 45.76, 45.77
     +, 45.77, 45.71, 45.45, 44.88, 43.99, 43.05, 42.35, 42.11, 42.42
     +, 43.15, 44.06, 44.98, 45.90, 46.87, 47.90, 48.93, 49.88, 50.60
     +, 50.92, 50.68, 49.83, 48.51, 46.91, 45.31, 43.95, 43.04, 42.69
     +, 42.85
C glat= 40,glon=0:10:360
     *, 47.46, 47.79, 48.20, 48.64, 49.06, 49.40, 49.61, 49.74, 49.82
     +, 49.87, 49.83, 49.58, 49.04, 48.24, 47.37, 46.66, 46.30, 46.37
     +, 46.80, 47.46, 48.22, 49.05, 49.95, 50.90, 51.83, 52.67, 53.29
     +, 53.54, 53.30, 52.56, 51.48, 50.26, 49.10, 48.16, 47.56, 47.34
     +, 47.46
C glat= 45,glon=0:10:360
     *, 51.32, 51.55, 51.85, 52.16, 52.48, 52.77, 52.99, 53.18, 53.32
     +, 53.41, 53.39, 53.15, 52.65, 51.94, 51.16, 50.49, 50.08, 50.01
     +, 50.24, 50.71, 51.34, 52.08, 52.90, 53.76, 54.60, 55.34, 55.87
     +, 56.06, 55.82, 55.18, 54.30, 53.35, 52.49, 51.81, 51.39, 51.24
     +, 51.32
C glat= 50,glon=0:10:360
     *, 54.70, 54.85, 55.06, 55.30, 55.55, 55.80, 56.05, 56.27, 56.47
     +, 56.59, 56.57, 56.36, 55.91, 55.29, 54.61, 54.01, 53.61, 53.46
     +, 53.58, 53.91, 54.42, 55.06, 55.79, 56.56, 57.30, 57.93, 58.38
     +, 58.52, 58.29, 57.75, 57.02, 56.27, 55.60, 55.09, 54.77, 54.65
     +, 54.70
C glat= 55,glon=0:10:360
     *, 57.78, 57.88, 58.03, 58.21, 58.42, 58.66, 58.91, 59.17, 59.39
     +, 59.54, 59.54, 59.35, 58.97, 58.43, 57.86, 57.35, 56.99, 56.83
     +, 56.88, 57.12, 57.53, 58.06, 58.68, 59.34, 59.97, 60.51, 60.87
     +, 60.96, 60.74, 60.28, 59.68, 59.08, 58.55, 58.15, 57.89, 57.77
     +, 57.78
C glat= 60,glon=0:10:360
     *, 60.74, 60.80, 60.90, 61.05, 61.23, 61.45, 61.70, 61.97, 62.21
     +, 62.37, 62.40, 62.24, 61.91, 61.48, 61.01, 60.60, 60.30, 60.16
     +, 60.18, 60.36, 60.67, 61.10, 61.60, 62.14, 62.66, 63.10, 63.38
     +, 63.42, 63.22, 62.82, 62.33, 61.85, 61.42, 61.09, 60.87, 60.76
     +, 60.74
C glat= 65,glon=0:10:360
     *, 63.70, 63.72, 63.80, 63.91, 64.08, 64.28, 64.52, 64.77, 65.01
     +, 65.18, 65.22, 65.10, 64.85, 64.51, 64.16, 63.84, 63.62, 63.50
     +, 63.51, 63.64, 63.87, 64.20, 64.58, 65.00, 65.40, 65.74, 65.94
     +, 65.95, 65.75, 65.41, 65.02, 64.64, 64.30, 64.03, 63.84, 63.73
     +, 63.70
C glat= 70,glon=0:10:360
     *, 66.78, 66.78, 66.84, 66.93, 67.07, 67.24, 67.45, 67.67, 67.89
     +, 68.05, 68.11, 68.04, 67.86, 67.62, 67.37, 67.15, 67.00, 66.91
     +, 66.92, 67.00, 67.17, 67.40, 67.67, 67.97, 68.26, 68.50, 68.63
     +, 68.59, 68.40, 68.13, 67.83, 67.54, 67.28, 67.07, 66.92, 66.82
     +, 66.78
C glat= 75,glon=0:10:360
     *, 70.13, 70.13, 70.17, 70.24, 70.34, 70.48, 70.63, 70.81, 70.98
     +, 71.11, 71.18, 71.17, 71.07, 70.92, 70.77, 70.64, 70.54, 70.49
     +, 70.49, 70.54, 70.65, 70.79, 70.96, 71.15, 71.34, 71.49, 71.55
     +, 71.47, 71.31, 71.10, 70.89, 70.68, 70.50, 70.36, 70.24, 70.17
     +, 70.13
C glat= 80,glon=0:10:360
     *, 73.98, 73.98, 74.00, 74.04, 74.11, 74.19, 74.29, 74.40, 74.51
     +, 74.61, 74.68, 74.70, 74.68, 74.62, 74.56, 74.49, 74.45, 74.42
     +, 74.42, 74.45, 74.50, 74.58, 74.67, 74.77, 74.87, 74.93, 74.91
     +, 74.81, 74.69, 74.56, 74.43, 74.31, 74.21, 74.12, 74.05, 74.00
     +, 73.98
C glat= 85,glon=0:10:360
     *, 78.83, 78.83, 78.84, 78.86, 78.88, 78.92, 78.96, 79.00, 79.04
     +, 79.09, 79.13, 79.16, 79.19, 79.20, 79.20, 79.20, 79.19, 79.19
     +, 79.20, 79.21, 79.23, 79.26, 79.29, 79.33, 79.32, 79.27, 79.22
     +, 79.16, 79.11, 79.06, 79.01, 78.96, 78.92, 78.89, 78.86, 78.84
     +, 78.83
C glat= 90,glon=0:10:360
     +, 90., 90., 90., 90., 90., 90., 90., 90., 90., 90., 90., 90., 90.
	+, 90., 90., 90., 90., 90., 90., 90., 90., 90., 90., 90., 90., 90.
     +, 90., 90., 90., 90., 90., 90., 90., 90., 90., 90., 90./

c/  111	format(A100)
c/      open(11,file=filenam,form='FORMATTED')
c/      read(11,111) txt
c/      do i=-lathp,lathp
c+	  do i=-18,18
c/         read(11,*) (pmodip(i+lathp+1,j+lnghp),j=-lnghp,lnghp)
c+         read(11,*) (pmodip(i+19,j+18),j=-18,18) !line=1,2...,37;clm=0,1,36
c/      enddo
c/      close(unit=11)
crem      do i=0,lngp
c+      do i=0,36
crem         pmodip(0,i)=pmodip(2,mod((i+lnghp),lngp))
c+         pmodip(0,i)=pmodip(2,mod((i+36),36))		  !clm=-1,1,1,
crem         pmodip(latp+2,i)=pmodip(latp,mod((i+lnghp),lngp))
c+         pmodip(38,i)=pmodip(36,mod((i+36),36))
crem         pmodip(latp+3,i)=pmodip(latp-1,mod((i+lnghp),lngp))
c+         pmodip(39,i)=pmodip(35,mod((i+36),36))
crem      enddo
crem      do i=0,latp+3
crem         pmodip(i,-1)=pmodip(i,lngp-1)
crem         pmodip(i,lngp+1)=pmodip(i,1)
crem      enddo
C New interpolate for IONEX grids:
	glat=-90.
	do lat=1,71,2
	glat=glat+2.5
	ip=lat/2+1			  ! 1,3,...,37 lat(step=5deg.)

C cycle to interpolate longs= for -180:5:180
	glong=-185.
	do lon=0,72                !<<<<<<<<<<<<<<<<
	glong=glong+5.
	jlon=lon/2
C re-arrange two lines for longi=-180:10:180
	 do ii=0,36
	if (ii.ge.18) then
	am1(ii-18)=pmodip(ii,ip)
	am2(ii-18)=pmodip(ii,ip+1)
	am(ii-18)=(am1(ii-18)+am2(ii-18))/2. ! intermediate latitude
	else
	am1(ii+18)=pmodip(ii,ip)
	am2(ii+18)=pmodip(ii,ip+1)
	am(ii+18)=(am1(ii+18)+am2(ii+18))/2. ! intermediate latitude
	endif
	enddo
	am1(36)=am1(0)
	am2(36)=am2(0)
	am(36)=am(0)
	if (lon.eq.jlon*2) then
	resmodip(lat,lon)=am(jlon)
	if (lat.lt.71) resmodip(lat+1,lon)=am2(jlon)
	                   else
	resmodip(lat,lon)=(am(jlon)+am(jlon+1))/2.	  !intermediate longitude
	if (lat.lt.71) resmodip(lat+1,lon)=(am2(jlon)+am2(jlon+1))/2.
	endif
	enddo                         !>>>>>>>>>>>>>>>>>>>>
	ENDDO
      return
      end
C-----------------------------------------------------------------
      subroutine sdec(mth,UT,sdelta,cdelta)
      parameter (DR=1.745329252E-2)

      doy=mth*30.5-15.0
      t =doy + (18.0-UT)/24.0
      amrad=(0.9856*t - 3.289)*DR
      aLrad = amrad + (1.916*sin(amrad)+0.02*sin(2.0*amrad)+
     + 282.634)*DR
      sdelta=0.397820*sin(aLrad)
      cdelta=sqrt(1.0-sdelta*sdelta)
      return
      end
      subroutine ef1r(alat,mth,flx,chi,efoE)
      parameter (DR=1.745329252E-2)
      parameter (chi0=86.232928)
      chin=djoin(90.0-0.24*fexp(20.0-0.20*chi),chi,12.0,
     & chi-chi0)
      ee=fexp(0.3*alat)
      seas=1.0-2.0/(ee+1.0)
      if(mth.eq.1.or.mth.eq.2.or.mth.eq.11.or.mth.eq.12) 
     +  sfac=(1.112+0.019*seas)*flx**0.25
      if(mth.eq.3.or.mth.eq.4.or.mth.eq.9.or.mth.eq.10)
     +  sfac=1.112*flx**0.25
      if(mth.eq.5.or.mth.eq.6.or.mth.eq.7.or.mth.eq.8)
     +  sfac=(1.112-0.019*seas)*flx**0.25
      fa=sfac*fexp(log(cos(chin*DR))*0.3)
      efoE=sqrt(fa*fa+0.49)
      return
      end
C-----------------------------------------------------------------
	      real function djoin(f1,f2,alpha,x)
      real f1,f2,alpha,x,ee,fexp
      ee=fexp(alpha*x)
      djoin=(f1*ee+f2)/(ee+1.0)
      return
      end
C-----------------------------------------------------------------
       real function fexp(a)
      real a
      if(a.gt.80.0) then
         fexp=5.5406E34
         return
      endif
      if(a.lt.-80.0D0) then
         fexp=1.8049E-35
         return
      endif
      fexp=exp(a)
      return
      end
C-----------------------------------------------------------------

