      real function NeQuicka1(h)
      real NeNeQ
	real Plas1
      dimension hm(3),aep(3),bb(6)
	COMMON /bplas/rzs,plat,plong,put,ldaynr,heitop,eltop

CREM      call prepNeQ(alat,along,mth,UT,flx,hm,aep,bb)

C Determine height heitop at eltop=0.5*NmF2 for Plasmasphere starting height:
c-??	call prepPlas(hm,aep,bb)

C choose option Ionophere or Plasmasphere:
	if(h.lt.heitop) then
      NeQuicka1= NeNeQ(h,hm,aep,bb)
	else

	NeQuicka1=Plas1(h)
      endif
	return
      end
C---------------------------------------------------------------------------------------
C-------------------------------------------------------------
      real function elda(s,pp,Re,s1,c1,ssig,csig,along1)
C Modified for Plasmasphere              Sep. 2013 T.L. Gulyaeva
C
C  gives electron density as a function of the coordinate s
C    (distance from the perigee of the ray)
C
      real NeQuicka1
      common /timin/flx,UT,mth
	COMMON /bplas/rzs,alat,along,put,ldaynr,heitop,eltop
 
      parameter (RD=57.2957795)
      tdel=s/pp
      cdel=1.0/sqrt(1.0+tdel*tdel)
      sdel=tdel*cdel
      arg=s1*cdel+c1*sdel*csig
      alat=atan2(arg,sqrt(1.0-arg*arg))*RD
      clong=atan2(sdel*ssig*c1,cdel-s1*arg)*RD
      along=clong+along1
      h=sqrt(s*s+pp*pp)-Re
C
	if (h.lt.heitop) then
      elda=NeQuicka1(h)
	else
	elda=Plas1(h)
	endif
      return
      end
C--------------------------------------
      real function gintv (g1,g2,eps,hm,aep,bb)
C  special; integrates NeNeQ for vertical profile
      real NeNeQ
      dimension hm(3),aep(3),bb(6)
c-      common /nepar/hm,aep,bb
         gint1 = 0.0
         n = 8
    1    h  =  (g2-g1) / dfloat(n)
         hh = 0.5*h
         g  = h*0.57735027
         y  = g1 + (h-g)*0.5
         gint2  =  NeNeQ(y,hm,aep,bb)+
     +             NeNeQ(y+g,hm,aep,bb)
         do m = 1,n-1
            gint2 = gint2 + NeNeQ(y+h+g,hm,aep,bb)+
     +                      NeNeQ(y+h,hm,aep,bb)
            y = y + h
         enddo
         gint2 = gint2*hh
         if (n.eq.8.or.abs(gint1-gint2).gt.eps*abs(gint1)) then
            n = n*2
            gint1 = gint2
            if (n.lt.1024) goto 1
         endif
         gintv = gint2+(gint2-gint1)/15.0
      return
      end
