C-----------------------------------------------------------------
      real function amodip(pmodip,alat,along)

      dimension pmodip(0:39,-1:37)
      dimension z(4),z1(4)
      parameter(lngp=36,dlatp=5.0,dlngp=10.0)
	common /BLOKP/pmodip
      along1=amod(along+360.0,360.0) 
      dlng1=(along1+180.0)/dlngp
      dlng1=dlng1-aint(dlng1)
      j1=int((along1+180.0)/dlngp)-2
      if (j1.lt.0) j1=j1+lngp
      if (j1.gt.lngp-3) j1=j1-lngp
      a=(alat+90.0)/dlatp+1.0
      i=int(a)-2
      a=a-float(i+2)
      do k = 1,4
         do j=1,4
         z1(j)=pmodip(i+j,j1+k)
         enddo
         z(k)=finter3(z1,a)
      enddo
      amodip=finter3(z,dlng1)
      return
      end
C-----------------------------------------------------------------
        real function finter3(z,x)
      dimension z(4),a(0:3)

      dx=x+x-1.0D0
      if (abs(dx+1.0D0).lt.1.0D-10) then
         finter3=z(2)
      else
         g1=(z(3)+z(2))
         g2=(z(3)-z(2))
         g3=(z(4)+z(1))
         g4=(z(4)-z(1))/3.0D0
         a(0)=(9.0D0*g1-g3)
         a(1)=(9.0D0*g2-g4)
         a(2)=(g3-g1)
         a(3)=(g4-g2)
         zi=0.0D0
         do j=3,0,-1
            zi=zi*dx+a(j)
         enddo
         finter3=zi/16.0D0
      endif
      return
      end
C-----------------------------------------------------------------
