C					                                  Feb. 2014
C
C       Count global CCIR-based median afc(UT) and ahc*UT) from CCIR maps fcF2 and hcF2(from M3000 map) 
C       for given UT 
      subroutine subsmi2(nnn,AYEAR,AMN,ADY,IMED)
C
C      output	fcYYMMUT.mut; hcYYMMUT.mut; tcYYMMUT.mut;
C
      DIMENSION im(12),da(7,71,0:72),av(0:72),iav(0:72)
	+,CC(7,0:72)  ! calculate med-map line-by-line for 71 latitudes
	+,IMED(71,0:72,0:23) ! results of median maps 
      character*2 ayr,amn,ady,aut,adyr,amnr
	character*1 fht
	character*45 infile
	CHARACTER*128 TXT
	character*4 AYEAR
	integer*2 iyr,mn,idy,iut,imn
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
			COMMON /BL1/CC,AV

c
c Add cycle on fm, hm, tm:
c
	if (nnn.eq.1) fht='t'
	if (nnn.eq.2) fht='f'
	if (nnn.eq.3) fht='h'
c
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c//       write(*,*) 'ENTER YEAR:'
c//	 read(*,*) AYEAR
	AYR=AYEAR(3:4)
c//       write(*,*) 'ENTER MN:'
c//	 read(*,*) AMN
		read(ayr,*) yr
		read(amn,*) rmn
	mn=int(rmn)
C
 	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	ndnr=im(mn)
C
		read(ady,*) rdy
	jdy=int(rdy)
	ldac=ndoy(iyr,mn,jdy)
	lda0=ldac-7
	lda1=ldac-1
C 
C
       infile='d:\web\graf\dfc\yy\mm\ut\fcmmddut.jyr'	 !Tamara
	infile(14:14)=fht								 !Tamara
	infile(26:26)=fht								 !Tamara
	infile(17:18)=ayr								 !Tamara
	infile(36:37)=ayr								 !Tamara
C
C UT cycle
	DO 203 iut=0,23
	call blet2(iut,AUT)
	infile(32:33)=AUT								 !Tamara

C Day-to-day cycle
	DO 201 lda=lda0,lda1
	kk=lda-lda0+1
	call submmdd(lda,iyr,imn,idy)
C
	call blet2(imn,amnr)
	call blet2(idy,adyr)
	infile(20:21)=amnr								 !Tamara
	infile(28:29)=amnr								 !Tamara
	infile(30:31)=adyr								 !Tamara
C
   18	continue
C
C++  Rename file extension tc* or ta* / tb* for prediction files
  700 format(A128)
	INFILE(27:27)='c'								 !Tamara
C++ Check availability of INFILE
C
      OPEN(11,FILE=INFILE)
       read(11,700,END=701,ERR=701) txt
	backspace(11)
	goto 704
C
c//	            if (txt.eq.'') then  ! no tc* data
  701	close(unit=11)
	INFILE(27:27)='a'								 !Tamara
		OPEN(11,FILE=INFILE) 
	read(11,700,END=702,ERR=702) txt
	backspace(11)
	goto 704
C
c//	   if (txt.eq.'') then	  ! no ta* data 
  702 	close(unit=12)
	INFILE(27:27)='b'								 !Tamara
		OPEN(11,FILE=INFILE) 
	read(11,700,END=703,ERR=703) txt
	backspace(11)
	goto 704
C
c//	if (txt.eq.'') then	  ! no tb* data 
  703	close(unit=11)
	write(*,*) 'No file: ',infile
	pause ' '
	stop
C
 704 	 continue
C
C
	do lat=1,71
  107 format(73(1X,F4.0))	! 
	READ (11,107,END=99,ERR=2) (da(kk,lat,k),k=0,72) !map lines
	enddo				   ! end lati
   99	close(unit=11)
 
  201  CONTINUE				  ! end day-to-day cycle

	do 301 lat=1,71
	do k=0,72
	av(k)=0.
	enddo
C combile all days for selected lati:
	do idy=1,7
      	do lon=0,72
	    cc(idy,lon)=da(idy,lat,lon)
	    enddo
	enddo
	call smedian1(7)
	  	do lon=0,72
	iav(lon)=nint(av(lon))
	IMED(lat,lon,iut)=iav(lon) ! results of median map
	    enddo
c	   write(*,109) (iav(k),k=0,72)

  301	continue                 ! end lat cycle of median map

  203 continue   ! end ut cycle
 
  108 format(3A2,24(1X,I4))	! 
  109 format(73(1X,I4))	! 
      
C
       GOTO 1234
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile
 	pause ' '
	goto 34
 1234	continue  !
c//      write(*,*) infile,outfile
c//      pause ' ' 
   34 RETURN
       END
C==============================================================================
C
      REAL FUNCTION F2OUT(XMODIP,XLATI,XLONGI,R,HOUR)
C     D.BILITZA,20.8.78. PACET XHMF2  NMF2 C COOBAHEM
C     KAPT MKKP(CCIR)  FOF2  M3000.
      DIMENSION FF0(988),MQF(9),F2(13,76,2)
      COMMON /BLOKA/F2
      DATA MQF/11,11,8,4,1,0,0,0,0/
      DO 20 I=1,76
      DO 20 J=1,13
      K=J+13*(I-1)
   20 FF0(K)=(F2(J,I,1)*(100.0-R)+F2(J,I,2)*R)/100.0
      F2OUT=GAMMA1(XMODIP,XLATI,XLONGI,.FALSE.,HOUR,6,MQF,9,76,13,988,
     &FF0)
      RETURN
      END

      REAL FUNCTION HF2OUT(XMODIP,XLATI,XLONGI,XMAGBR,XR,HOUR,FOE,FOF2,
     &DAY,XMLAT,XM3000)
C Calculation of hmF2 from foF2, xM3000, Modip (XMAGBR), Glat, Glong,hour, foE,day,xmlat 
      DIMENSION MQM(7),XMM0(441),FM3N(9,49,2),FM3S(9,49,2)
      COMMON /BLOKB/FM3N,FM3S
      DATA MQM/6,7,5,2,1,0,0/
      R=200.*XR/(XR**8+2.56E18)**0.125
      ABML=ABS(XMLAT)
      YLATI=ABS(XLATI)
      IF ((XLATI.GE.0.).OR.((XMLAT+11.4).GE.0.)) GO TO 15
      DO 10 I=1,49
      DO 10 J=1,9
      K=J+9*(I-1)
   10 XMM0(K)=(FM3S(J,I,1)*(100.0-R)+FM3S(J,I,2)*R)/100.0
      XM3000=GAMMA1(XMODIP,YLATI,XLONGI,.FALSE.,HOUR,4,MQM,7,49,9,441,
     *XMM0)
      GO TO 30
   15 CONTINUE
      DO 20 I=1,49
      DO 20 J=1,9
      K=J+9*(I-1)
   20 XMM0(K)=(FM3N(J,I,1)*(100.0-R)+FM3N(J,I,2)*R)/100.0
      XM3000=GAMMA1(XMODIP,XLATI,XLONGI,.FALSE.,HOUR,4,MQM,7,49,9,441,
     *XMM0)
   30 HF2OUT=HMF2ED(XMAGBR,R,FOF2/FOE,XM3000,HOUR,DAY,ABML)
      RETURN
      END
C
      SUBROUTINE CCIRCA(IMONTH)
C     Calculation of coefficients
C     FOF2(76,13)  SM3000(49,9) 
C     for level of solar activity, MODIP and month 
C     using CCIR maps
      DIMENSION F2(13,76,2),FM3N(9,49,2),FM3S(9,49,2)
      COMMON /BLOKA/F2/BLOKB/FM3N,FM3S
      MON=IMONTH+6
      IF (MON.GT.12) MON=MON-12
      READ (16,rec=mon) F2,FM3S
      REWIND 16
      READ (16,rec=imonth) F2,FM3N
      REWIND 16
      RETURN
      END
C
      REAL FUNCTION HMF2EDS(XR,X,XM3,HOUR,DAY,ABML)
C     D. BILITZA, F2 layer peak height (HMF2) for corrected magnetic 
C     latitude (HMLAT) and sunspot number (XR) using coefficient
C     M3000(XM3) and ratio of FOF2/FOE.
C     [Ref. D. BILITZA ET. AL. TELECOMM.J.,46,549-553,1979]
C     hmF2EDS = SMI option includes HOUR (LT), DAY, ABS(MLAT) input and
C     parameters of COMMON Blocks: Solar zenith angle XHI and 
C     corrected magnetic latitute HMLAT
C
      COMMON /BLO11/XHI/B6/HMLAT,H0NE,GLT,FG1,FG2
      F1=(2.32E-3)*XR+0.222
      F2=1.2-(1.16E-2)*EXP((2.39E-2)*XR)
      F3=0.096*(XR-25.0)/150.0
      XMIN=1.7
      IF (ABS(HMLAT).LT.64.) GO TO 1
      XZ=(XHI-65.)/6.
      XZ1=XZ*XZ
      XZ1=XZ1*XZ1
      RBA=(XZ1+16.)**0.25
      RB=0.25*XZ/RBA+1.95
      XZ=(XHI-74.)/6.
      XZ1=XZ*XZ
      XZ1=XZ1*XZ1
      RHA=(XZ1+16.)**0.25
      RH=0.2*XZ/RHA+1.70
      XMIN=(RB-RH)*(XR-10.)/140.+RH
    1 IF (X.LT.XMIN) X=XMIN
      DELM=F1*(1.0-XR/150.0*EXP(-HMLAT*HMLAT/1600.0))/(X-F2)+F3
      HMF2EDS=1490./(XM3+DELM)-176.
      IF (ABML.LT.30.) HMF2EDS=HMF2EDS*DELH(HOUR,DAY,ABML)
      RETURN
      END
C
      REAL FUNCTION GAMMA1(SMODIP,SLAT,SLONG,HOUR,IHARM,NQ,
     &                          K1,M,MM,M3,SFE)
C CALCULATES GAMMA1=FOF2 OR M3000 USING CCIR NUMERICAL MAP
C COEFFICIENTS SFE(M3) FOR MODIFIED DIP LATITUDE (SMODIP/DEG)
C GEOGRAPHIC LATITUDE (SLAT/DEG) AND LONGITUDE (SLONG/DEG)
C AND UNIVERSIAL TIME (HOUR/DECIMAL HOURS).
C NQ(K1) IS AN INTEGER ARRAY GIVING THE HIGHEST DEGREES IN
C LATITUDE FOR EACH LONGITUDE HARMONIC.
C M=1+NQ1+2(NQ2+1)+2(NQ3+1)+... .
C SHEIKH,4.3.77.
      REAL*8 C(12),S(12),COEF(100),SUM
      DIMENSION NQ(K1),XSINX(13),SFE(M3)
      COMMON/CONST/UMR
      HOU=(15.0*HOUR-180.0)*UMR
      S(1)=SIN(HOU)
      C(1)=COS(HOU)
      DO 250 I=2,IHARM
      C(I)=C(1)*C(I-1)-S(1)*S(I-1)
      S(I)=C(1)*S(I-1)+S(1)*C(I-1)
250   CONTINUE
      DO 300 I=1,M
      MI=(I-1)*MM
      COEF(I)=SFE(MI+1)
      DO 300 J=1,IHARM
      COEF(I)=COEF(I)+SFE(MI+2*J)*S(J)+SFE(MI+2*J+1)*C(J)
300   CONTINUE
      SUM=COEF(1)
      SS=SIN(SMODIP*UMR)
      S3=SS
      XSINX(1)=1.0
      INDEX=NQ(1)
      DO 350 J=1,INDEX
      SUM=SUM+COEF(1+J)*SS
      XSINX(J+1)=SS
      SS=SS*S3
350   CONTINUE
      XSINX(NQ(1)+2)=SS
      NP=NQ(1)+1
      SS=COS(SLAT*UMR)
      S3=SS
      DO 400 J=2,K1
      S0=SLONG*(J-1.)*UMR
      S1=COS(S0)
      S2=SIN(S0)
      INDEX=NQ(J)+1
      DO 450 L=1,INDEX
      NP=NP+1
      SUM=SUM+COEF(NP)*XSINX(L)*SS*S1
      NP=NP+1
      SUM=SUM+COEF(NP)*XSINX(L)*SS*S2
450   CONTINUE
      SS=SS*S3
400   CONTINUE
      GAMMA1=SUM
      RETURN
      END
C
C
C************************************************************
C*************** EARTH MAGNETIC FIELD ***********************
C**************************************************************
C
C
      SUBROUTINE GGM(ART,LONG,LATI,MLONG,MLAT)
C CALCULATES GEOMAGNETIC LONGITUDE (MLONG) AND LATITUDE (MLAT)
C FROM GEOGRAFIC LONGITUDE (LONG) AND LATITUDE (LATI) FOR ART=0
C AND REVERSE FOR ART=1. ALL ANGLES IN DEGREE.
C LATITUDE:-90 TO 90. LONGITUDE:0 TO 360 EAST.
      INTEGER ART,DAYNR
      REAL MLONG,MLAT,LONG,LATI,longi
      COMMON/CONST/FAKTOR
	&/dem/w,glongi,hour,daynr,cn1000,alon,blon,enre,HSC
      ZPI=FAKTOR*360.
      CBG=11.4*FAKTOR
      CI=COS(CBG)
      SI=SIN(CBG)
      IF(ART.EQ.0) GOTO 10
      CBM=COS(MLAT*FAKTOR)
      SBM=SIN(MLAT*FAKTOR)
      CLM=COS(MLONG*FAKTOR)
      SLM=SIN(MLONG*FAKTOR)
      SBG=SBM*CI-CBM*CLM*SI
      IF(ABS(SBG).GT.1.) SBG=SIGN(1.,SBG)
      LATI=ASIN(SBG)
      CBG=COS(LATI)
      SLG=(CBM*SLM)/CBG
      CLG=(SBM*SI+CBM*CLM*CI)/CBG
      IF(ABS(CLG).GT.1.) CLG=SIGN(1.,CLG)
      LONG=ACOS(CLG)
      IF(SLG.LT.0.0) LONG=ZPI-LONG
      LATI=LATI/FAKTOR
      LONG=LONG/FAKTOR
      LONG=LONG-69.8
      IF(LONG.LT.0.0) LONG=LONG+360.0
	longi=long
      RETURN
10    YLG=LONG+69.8
      CBG=COS(LATI*FAKTOR)
      SBG=SIN(LATI*FAKTOR)
      CLG=COS(YLG*FAKTOR)
      SLG=SIN(YLG*FAKTOR)
      SBM=SBG*CI+CBG*CLG*SI
      IF(ABS(SBM).GT.1.) SBM=SIGN(1.,SBM)
      MLAT=ASIN(SBM)
      CBM=COS(MLAT)
      SLM=(CBG*SLG)/CBM
      CLM=(-SBG*SI+CBG*CLG*CI)/CBM
      IF(ABS(CLM).GT.1.) CLM=SIGN(1.,CLM)
      MLONG=ACOS(CLM)
      IF(SLM.LT..0) MLONG=ZPI-MLONG
      MLAT=MLAT/FAKTOR
      MLONG=MLONG/FAKTOR
      RETURN
      END
C
C
      SUBROUTINE FIELDG(DLAT,DLONG,ALT,X,Y,Z,F,DIP,DEC,SMODIP)
C THIS IS A SPECIAL VERSION OF THE POGO 68/10 MAGNETIC FIELD
C LEGENDRE MODEL. TRANSFORMATION COEFF. G(144) VALID FOR 1973.
C INPUT: DLAT, DLONG=GEOGRAPHIC COORDINATES/DEG.(-90/90,0/360),
C        ALT=ALTITUDE/KM.
C OUTPUT: F TOTAL FIELD (GAUSS), Z DOWNWARD VERTICAL COMPONENT
C        X,Y COMPONENTS IN THE EQUATORIAL PLANE (X TO ZERO LONGITUDE).
C        DIP INCLINATION ANGLE(DEGREE). SMODIP RAWER'S MODFIED DIP.
C SHEIK,1977.
      DIMENSION H(144),XI(3),G(144),FEL1(72),FEL2(72)
      COMMON/CONST/UMR
      DATA FEL1/0.0, 0.1506723,0.0101742, -0.0286519, 0.0092606,
     & -0.0130846, 0.0089594, -0.0136808,-0.0001508, -0.0093977,
     & 0.0130650, 0.0020520, -0.0121956, -0.0023451, -0.0208555,
     & 0.0068416,-0.0142659, -0.0093322, -0.0021364, -0.0078910,
     & 0.0045586,  0.0128904, -0.0002951, -0.0237245,0.0289493,
     & 0.0074605, -0.0105741, -0.0005116, -0.0105732, -0.0058542,
     &0.0033268, 0.0078164,0.0211234, 0.0099309, 0.0362792,
     &-0.0201070,-0.0046350,-0.0058722,0.0011147,-0.0013949,
     & -0.0108838,  0.0322263, -0.0147390,  0.0031247, 0.0111986,
     & -0.0109394,0.0058112,  0.2739046, -0.0155682, -0.0253272,
     &  0.0163782, 0.0205730,  0.0022081, 0.0112749,-0.0098427,
     & 0.0072705, 0.0195189, -0.0081132, -0.0071889, -0.0579970,
     & -0.0856642, 0.1884260,-0.7391512, 0.1210288, -0.0241888,
     & -0.0052464, -0.0096312, -0.0044834, 0.0201764,  0.0258343,
     &0.0083033,  0.0077187/
      DATA FEL2/0.0586055,0.0102236,-0.0396107,
     & -0.0167860, -0.2019911, -0.5810815,0.0379916,  3.7508268,
     & 1.8133030, -0.0564250, -0.0557352, 0.1335347, -0.0142641,
     & -0.1024618,0.0970994, -0.0751830,-0.1274948, 0.0402073,
     &  0.0386290, 0.1883088,  0.1838960, -0.7848989,0.7591817,
     & -0.9302389,-0.8560960, 0.6633250, -4.6363869, -13.2599277,
     & 0.1002136,  0.0855714,-0.0991981, -0.0765378,-0.0455264,
     &  0.1169326, -0.2604067, 0.1800076, -0.2223685, -0.6347679,
     &0.5334222, -0.3459502,-0.1573697,  0.8589464, 1.7815990,
     &-6.3347645, -3.1513653, -9.9927750,13.3327637, -35.4897308,
     &37.3466339, -0.5257398,  0.0571474, -0.5421217,  0.2404770,
     & -0.1747774,-0.3433644, 0.4829708,0.3935944, 0.4885033,
     &  0.8488121, -0.7640999, -1.8884945, 3.2930784,-7.3497229,
     & 0.1672821,-0.2306652, 10.5782146, 12.6031065, 8.6579742,
     & 215.5209961, -27.1419220,22.3405762,1108.6394043/
      K=0
      DO 10 I=1,72
      K=K+1
      G(K)=FEL1(I)
10    G(72+K)=FEL2(I)
      RLAT=DLAT*UMR
      CT=SIN(RLAT)
      ST=COS(RLAT)
      NMAX=11
      D=SQRT(40680925.0-272336.0*CT*CT)
      RLONG=DLONG*UMR
      CP=COS(RLONG)
      SP=SIN(RLONG)
      ZZZ=(ALT+40408589.0/D)*CT/6371.2
      RHO=(ALT+40680925.0/D)*ST/6371.2
      XXX=RHO*CP
      YYY=RHO*SP
      RQ=1.0/(XXX*XXX+YYY*YYY+ZZZ*ZZZ)
      XI(1)=XXX*RQ
      XI(2)=YYY*RQ
      XI(3)=ZZZ*RQ
      IHMAX=NMAX*NMAX+1
      LAST=IHMAX+NMAX+NMAX
      IMAX=NMAX+NMAX-1
      DO 100 I=IHMAX,LAST
100   H(I)=G(I)
      DO 200 K=1,3,2
      I=IMAX
      IH=IHMAX
300   IL=IH-I
      F1=2./(I-K+2.)
      X1=XI(1)*F1
      Y1=XI(2)*F1
      Z1=XI(3)*(F1+F1)
      I=I-2
      IF((I-1).LT.0) GOTO 400
      IF((I-1).EQ.0) GOTO 500
      DO 600 M=3,I,2
      H(IL+M+1)=G(IL+M+1)+Z1*H(IH+M+1)+X1*(H(IH+M+3)-H(IH+M-1))-
     &Y1*(H(IH+M+2)+H(IH+M-2))
      H(IL+M)=G(IL+M)+Z1*H(IH+M)+X1*(H(IH+M+2)-H(IH+M-2))+
     &Y1*(H(IH+M+3)+H(IH+M-1))
600   CONTINUE
500   H(IL+2)=G(IL+2)+Z1*H(IH+2)+X1*H(IH+4)-Y1*(H(IH+3)+H(IH))
      H(IL+1)=G(IL+1)+Z1*H(IH+1)+Y1*H(IH+4)+X1*(H(IH+3)-H(IH))
400   H(IL)=G(IL)+Z1*H(IH)+2.0*(X1*H(IH+1)+Y1*H(IH+2))
700   IH=IL
      IF(I.GE.K) GOTO 300
200   CONTINUE
      S=0.5*H(1)+2.0*(H(2)*XI(3)+H(3)*XI(1)+H(4)*XI(2))
      XT=(RQ+RQ)*SQRT(RQ)
      X=XT*(H(3)-S*XXX)
      Y=XT*(H(4)-S*YYY)
      Z=XT*(H(2)-S*ZZZ)
      F=SQRT(X*X+Y*Y+Z*Z)
      BRH0=Y*SP+X*CP
      Y=Y*CP-X*SP
      X=Z*ST-BRH0*CT
      Z=-Z*CT-BRH0*ST
      zdivf=z/f
      IF(ABS(zdivf).GT.1.) zdivf=SIGN(1.,zdivf)
      DIP=ASIN(zdivf)
      ydivs=y/sqrt(x*x+y*y)
      IF(ABS(ydivs).GT.1.) ydivs=SIGN(1.,ydivs)
      DEC=ASIN(ydivs)
      dipdiv=DIP/SQRT(DIP*DIP+ST)
      IF(ABS(dipdiv).GT.1.) dipdiv=SIGN(1.,dipdiv)
      SMODIP=ASIN(dipdiv)
      DIP=DIP/UMR
      DEC=DEC/UMR
      SMODIP=SMODIP/UMR
      RETURN
      END
C
C
C************************************************************
